#Example_2141  Geometry fit of myocardial finite element model to
#              SPAMM stripe intersection data.  Four bicubic 2D elements
#              are used. Fit is based on least squares error with smoothing.

#First construct 1D contours to be fitted to endo and epicardium

fem define coordinate;r;example_2141;example
fem define base;r;example_2141;example   #1D elements: r and theta are 
#                                        !  bicubic in xi
fem define node;r;;example               #default radii and slopes
fem define element;r;;example
fem define field;r;;example
fem define element;r;;example field                  
fem define window;c on 1
fem draw line                            #display contours before fitting
#                                        !  them
     
#Define data defining contours
                       
fem define data;r;example_2141_epi02norm;example  #Read in data which lies on
#                                        !  epicardium
fem define data;c xi elements 1..4                         
fem draw data                                        
fem draw data projection                                  
fem define fit;r;example_2141;example geometry elements 1..4   
fem fit geometry                                     
fem update node in 1                                 
fem draw line                                        
fem draw data projection                                   
fem cancel data                                         
fem hide data projection 

fem define data;r;example_2141_endo02norm;example #Read in data which lies on
#                                        !  endocardium
fem define data;c xi elements 5..8                         
fem draw data                                       
fem draw data projection                                   
fem define fit;r;example_2141;example geometry elements 5..8   
fem fit geometry                                     
fem update node in 1                                 
fem draw line                                       
fem draw data projection                                   
fem cancel data                                         
fem hide data projection     
fem cancel element                                         
fem cancel field                                        
fem cancel data               #cancel data to prepare for SPAMM line data

fem define nodes;w;example_2141_fitted       
#                     Next define the "reference" or undeformed
#                     element geometry using the above fitted contours
fem define coordinate;r;example_2141;example            
fem def base;r;example_2141_myo3;example     #two 2D bicubic hermite basis:
#                                        r is bicubic in xi1, xi2 
#                                        theta is bicubic in xi1, xi2 
fem def nodes;r;example_2141_fitted;example  
fem def element;r;example_2141_myo2;example    #four bicubic hermite elements
#fem def window;c on 1                     !if window not already displayed 
fem draw line  rgb=black                   #Display  elements
fem def data;r;example_2141_defxsecn;example  geom   #Input intersections
#                                                 from ref. config.
fem def data;c xi                                #Calculated xis for
#                                                 reference config.
fem def data;w;example_2141_defxsecn xi
fem can data                                    
fem def data;r;example_2141_undefxsecn;example geom  #Input intersections
#                                                 from deformed config.
fem def data;r;example_2141_defxsecn xi      #Input xis from reference
#                                                 intersections

#fem def im;r;example_2141_spamm13;example size 128  !Display SPAMM image (optional)                                            
#fem def im                                          
#fem ch lut start white end black                    
#fem draw line rgb=black                            
fem draw data  rgb=black                             
fem draw data trace                                  
fem def field;r;example_2141_myo2;example                
fem def fit;r;example_2141_weightp01;example  geom   #weighting values of .1
fem fit geom                                    
fem update node
                            
#fem hi im                    !Display SPAMM image (optional
#fem can im                                          
#fem def im;r;example_2141_spamm3;example size 128       
#fem def im                                         
fem draw li rgb=black          #Display fitted geometry
fem draw node                                   
fem draw data trace                                 
fem quit                                            
