#Example_2181  Fit a cylindrical polar mesh to catscan femur head data                                                              
                                                                                                                                    
fem                          #set the FEM environment                                                                               
fem define coo;r;femur_head;example                                                                                                     
#                            !define coordinates as 3D cylindrical polar,                                                           
#                             unsymmetric                                                                                           
fem define base;r;femur_head1;example                                                                                                   
#                            !define two bases: one Bicubic Hermite angle                                                           
#                             change scale factors, and the other Bilinear                                                          
#                             Lagrange                                                                                              
fem define node;r;femur_head;example                                                                                                    
#                            !reads in the definition of 80 nodes describing                                                        
#                             a femur head with a cylindrical polar mesh                                                            
fem define element;r;femur_head;example                                                                                                 
#                            !defines a 72 element femur head cylindrical                                                           
#                             polar mesh                                                                                            
fem define window;c          #calculates the window size to fit the mesh                                                            
fem define data;r;femur_head;example                                                                                                    
#                            !femur head scan data                                                                                  
fem define line;c            #calculates new line positions                                                                         
fem define data;c xi         #calculates the xi coordinates of the points at                                                        
#                             which the data is input                                                                               
fem change sata weight 0.01 in 1..8                                                                                                 
#                            !reduce the weighting applied to data in                                                               
#                             elements 1 to 8                                                                                       
fem change data weight 0.01 in 50,54,55,56                                                                                          
#                            !these elements should change rapidly                                                                  
fem define field;r;femur_head;example                                                                                                   
#                            !defines an 80 node femur head field                                                                   
fem define fit;r;geom;example    #all nodes uncoupled and unconstrained, no                                                             
#                             smoothing fit                                                                                         
fem update node in 1         #overwrite radial coordinate fit                                                                       
fem define base;r;femur_head2;example                                                                                                   
#                            !defines a bicubic Her angle change for r,                                                             
#                             theta, and z                                                                                          
fem update node deriv in 2   #calculates theta derivatives based on linear                                                          
#                             change                                                                                                
fem update node deriv in 3   #calculates z derivatives based on linear                                                              
#                             change                                                                                                
fem update node deriv        #recalculates derivatives of r, theta, and z                                                           
#                             with respect to arc length                                                                            
fem define base;r;femur_head3;example                                                                                                   
#                            !to bicubic Herm ARC LENGTH for r, theta, and z                                                        
fem define line;c            #recalculate scale factors, etc                                                                        
fem change coor to 1         #change to rectangular cartesian coordinates                                                           
fem quit                     #exit from CMISS                                                                                       
                                                                                                                                    
