#Example 21e1

# This example borrows heavily from example as, but does
# include more set up variables to make it more useful.

$\ = "\n"; # Setting the record separator so that 
           # any prints are echoed straight to the screen.

# Create some materials to be used for display
gfx create material gold amb 1 0.4 0 diff 1 0.7 0 spec 0.5 0.5 0.5 shininess 0.8

# Create a coordinate field to store the data points in
gfx define field coordinates finite_element number_of_components 3 real coordinate component_names x y z

$height = 76.8; # Height of image = 76.8 mm
$width = 76.8; # Same as height

$xpixel = 512; # Each image will be 512 x 512 pixels
$ypixel = 512;
$xscale = $xpixel/$width;
$yscale = $ypixel/$height;
$zdist = 0.6; # Each image is 1.2mm apart in the z direction

# The top image will have it's centre located at (0,0,0), with
# each subsequent image $zdist further down on the xy plane
$xorigin = 0.0;
$yorigin = 0.0;
$zorigin = 0.0;
$xbottom = $xorigin - $height/2.0;
$ybottom = $yorigin - $width/2.0;
$xtop = $xorigin + $height/2.0;
$ytop = $yorigin + $height/2.0;

# Set up the distances for the near and far clipping planes
$cp_dist = 500;
$cp_near = $cp_dist - 300;
$cp_far = $cp_dist + 300;

# Create the 3d window
gfx create window 1

# We will construct the slice numbers
# Note that we miss out every second one, ie we have:
# 001 003 005 ...
for $i ("001".."128") {
    if(($i % 2) == 1) {
        push(@slice_numbers,$i)
    }
} 

# Get what slice we are after
$slice_count = 0
$slice_num = $slice_numbers[$slice_count]

# Run the comfile foreach sub image
open com execute 1 digitise
