# CMISS(cm) command file 
# Written by Richard Boyes <r.boyes@auckland.ac.nz>

# Define cm parameters, coordinate system (3d rc)
# and basis functions (bicubic-hermite + sector)
fem def para;r;fit
fem def coord 3,1
fem def base;r;bicubic-sector

# Read in the initial mesh, which is to be 
# deformed to fit the data
fem def node;r;epi-init
fem def elem;r;epi-init
fem ex node
fem ex elem
# Define the data points from digitisation
fem def data;r;../../../21e1/cmiss_input/epi-sample

# Calculate the xi projections of these
# data points onto the elements. These
# projections are to be minimised (The basic
# idea behind fitting)
fem def xi;c close
fem list data error

# Define a field for nodes and elements
# to create room for the fit variables
fem def field;r;epi
fem def elem;r;epi field

# Define the fitting procedure.
# You will notice in the .ipfit file there
# are parameters there for smoothing via Sobolev
# weights on the derivatives. These weights are
# used to remove excessive 'wrinkling' of the fitted
# surface to your data. The smaller these numbers
# are, the closer the fit 'hugs' the data and the
# more wrinkled it can become. A good range is between
# 10.0E-1 to 10.0E-6
fem def fit;r;epi geometry

# Fit once
fem fit
fem update node fit

# Fit twice
#fem def xi;c close
#fem fit
#fem update node fit

# Fit thrice
#fem def xi;c close
#fem fit
#fem update node fit

# Write out the fitted node and elements
fem def node;w;epi
fem def elem;w;epi
# Export the nodes & elems, also the data error
# for viewing 
#fem export data;epi-data as epi-data error
fem ex node;epi as epi
fem ex elem;epi as epi
