
if(defined($ARGV[0]))
{
  $number = $ARGV[0];
  #print $number, "\n";
} else
{
  die("Error: No input argument to meshError.pl!\n");
}

use PDL;
#use PDL::Core "sclr";

my $target = sprintf("mesh_%02d.ipdata", $number);
my $v1 = getData($target);
my $v2 = getData("newLandmark.ipdata");
#my $v2 = getData("finalDataPts.ipdata");
my $normal = getImgNormal($target);
my $Npts = $v1->getdim(1);
my $sum = 0;
for(my $n=0;$n<$Npts;$n++)
{
  my $eT = $v2->slice(":,$n") - $v1->slice(":,$n");
  #my $eTs = sqrt(at($eT,0,0)**2 + at($eT,1,0)**2 + at($eT,2,0)**2);
  my $e3 = inner($normal->slice(":,$n"), $eT) x $normal->slice(":,$n");
  my $e12 = $eT - $e3;
  #print $e12, "\n";
  #$sum = sqrt(at($e12,0,0)**2 + at($e12,1,0)**2 + at($e12,2,0)**2);
  $sum = $sum + sqrt(at($e12,0,0)**2 + at($e12,1,0)**2 + at($e12,2,0)**2);;
}
#print "Total error (sum of Eucledian distance between data points: $sum\n";
print "Total marker error:  $sum\n";


######################################################################
sub getData
{
  my ($file) = @_;

  my $maxPoints = 10000;
  my $vec = zeroes(3,$maxPoints);
  $nPts=0;
  CORE::open(INFID, "$file") || die "Error: Couldn't open $file\n";
  
  while ($line = <INFID>)
  {
    if($line =~ m/\s*(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)/)
    {
      $tmp = $vec->slice(":,$nPts");
      $tmp .= pdl [$2,$3,$4];
      $nPts++;
    }
  }
  CORE::close(INFID);
  $nPts--;
  return($vec->slice(":,0:$nPts"));
}


sub getImgNormal
{
  my ($file) = @_;

  my $maxPoints = 10000;
  my $vec = zeroes(3,$maxPoints);
  $nPts=0;
  CORE::open(INFID, "$file") || die "Error: Couldn't open $file\n";
  
  while ($line = <INFID>)
  {
    if($line =~ m/\s*(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)/)
    {
      $tmp = $vec->slice(":,$nPts");
      $tmp .= pdl [$5,$6,$7];
      $nPts++;
    }
  }
  CORE::close(INFID);
  $nPts--;
  return($vec->slice(":,0:$nPts"));
}

