#this file can be run in the results directory
#to visualize the diffusion field in cmgui
#pls do not to run all commands at once, 
#but select and run the time loop as a whole

$host_file = 'output1';
$host_group = 'output1';

#Read in Geometry Information
#============================
####most cmds taken form example cube ak 
gfx read node $host_file time 0
gfx read elem $host_group

#Material Commands
#=================
gfx create material default ambient 1 1 1 diffuse 1 1 1 emission 0 0 0 specular 0 0 0 alpha 1 shininess 0
gfx create material isosurface ambient 0.5 0.51 1 diffuse 0.5 0.5 1 emission 0.1 0.1 0.1 specular 0.1 0.1 0.1 alpha 1 shininess 0.5
gfx create material yellow diff 1 1 0 amb 1 1 0 alpha 1
gfx create material red diff 1 0 0 amb 1 0 0
gfx create material extsurf amb 0 0 0 diffuse 0.2 0.2 0.5 alpha 0.2

#Axes
#=================

gfx create axes mat green len 1
gfx draw axes

#Window Commands
#===============

gfx create window 1 double_buffer
gfx modify window 1 image scene default light_model default
gfx modify window 1 image add_light default
gfx modify window 1 layout simple ortho_axes z -y eye_spacing 0.25 width 469 height 490
gfx modify window 1 set current_pane 1
gfx modify window 1 background colour 0 0 0

gfx modify window 1 view perspective eye_point 1 1 5.7697 interest_point 1 1 0. up_vector 0 1 0 view_angle 52.263 near_clipping_plane 0.057697 far_clipping_plane 20.6189 relative_viewport ndc_placement -1 1 2 2 viewport_coordinates 0 0 1 1

gfx modify window 1 overlay scene none
gfx modify window 1 set transform current_pane 1 std_view_angle 40 normal_lines no_antialias fast_transparency


#Spectrum Commands
#=================


gfx modify spectrum default clear overwrite_colour
#gfx modify spectrum default linear reverse range 0 0.5 extend_above extend_below rainbow colour_range 0 1 ambient diffuse
## Create an appropriate spectrum
## Total Min. = 0, Total Max. =  0.5
gfx create spectrum mySpectrum linear reverse range 0 0.5 extend_above extend_below rainbow colour_range 0 1 ambient diffuse


#Drawing Commands
#================

gfx modify g_element output1 general circle_discretization 6 element_discretization "12*12*12" native_discretization coordinates
gfx modify g_element output1 node_points glyph cube_wireframe general size "0.01*0.01*0.01" centre 0,0,0 select_on material default selected_material default_selected
gfx modify g_element output1 lines material red
gfx mod g_e output1 surfaces data general.1 spectrum mySpectrum


#Read in next time steps
#taken from example b232
#=======================

foreach $count ('001'..'100') {
 my $time = $count;
 print "time: $time\n";
 gfx read node "output1_$count" time $time       #read in the field


}

gfx timekeeper default play minimum 0 maximum 100
gfx timekeeper default stop set_time 0
gfx timekeeper default play speed 1
gfx create time_editor
 
 
 
