#include "stdio.h"
/* 
cc -o split_name split_name.c 
*/
#define MAX_SPHERES 5
#define NUM_SPHERES 3
enum Sphere_type
{
  BEM,
  FEM,
  INVALID
};

#define NOT_ACTUAL

void main(int argc,char **argv)
{
  char *name;
  int i,num_spheres,around,azimuthal,
    source_rad,top_limit,num_dof,linear;
  enum Sphere_type sphere_type[MAX_SPHERES];
  char conductivity[MAX_SPHERES];
  int radius[MAX_SPHERES];
  char source_dir,source_rad_dir,temp_type[4],temp_rad[5];
  FILE *comfile;

  for(i=0;i<MAX_SPHERES;i++)
  {
    sphere_type[i] = INVALID;
    radius[i] = 0;
    conductivity[i] = 'z';
  }
  if(argc==2)
  {
    name = argv[1];
    if(sscanf(name,"sphere_%i",&num_spheres)==1)
    {
      name += 8;
      for(i=0;i<num_spheres;i++)
      {
        if(sscanf(name,"_%3c%4c_%c",temp_type,temp_rad,&conductivity[i])==3)
        {
          name += 10;
          temp_type[3] = '\0';
          temp_rad[0] = '1';
          temp_rad[4] = '\0';
          radius[i] = atoi(temp_rad)-1000;
  if(!strcmp(temp_type,"bem"))
          {
            sphere_type[i] = BEM;
          }
          else if(!strcmp(temp_type,"fem"))
          {
            sphere_type[i] = FEM;
          }
          else
          {
            sphere_type[i] = INVALID;
          }
        }
        else
        {
          fprintf(stderr,"Could not get sphere information\n");
        }
      }
      if(sscanf(name,"_%d_%d_%d_%c_%c",&around,&azimuthal,
        &source_rad,&source_rad_dir,&source_dir)==5)
      {
        linear = 0;
        if(!strcmp(name+strlen(name)-7,"_linear"))
        {
          linear=1;
        }
        fprintf(stdout,"%i\n",num_spheres);
        for(i=0;i<NUM_SPHERES;i++)
        {
          switch(sphere_type[i])
          {
            case BEM:
            {
              fprintf(stdout,"bem\n");
            } break;
            case FEM:
            {
              fprintf(stdout,"fem\n");
            } break;
            default:
            {
              fprintf(stdout,"none\n");
            } break;
          }
#if defined (ACTUAL)
          fprintf(stdout,"%03i\n",radius[i]);
#else
          fprintf(stdout,"%f\n",(double)(radius[i]/100.0));
#endif
#if defined (ACTUAL)
          fprintf(stdout,"%c\n",conductivity[i]);
#else
          switch(conductivity[i])
          {
            case '1':
            case 'z':
            {
              fprintf(stdout,"1\n");
            } break;
            case '2':
            {
              fprintf(stdout,"2\n");
            } break;
            case '3':
            {
              fprintf(stdout,"4\n");
            } break;
            case '4':
            {
              fprintf(stdout,"8\n");
            } break;
            case '5':
            {
              fprintf(stdout,"16\n");
            } break;
            case '6':
            {
              fprintf(stdout,"32\n");
            } break;
            case '7':
            {
              fprintf(stdout,"64\n");
            } break;
            case '8':
            {
              fprintf(stdout,"100\n");
            } break;
            case 'a':
            {
              fprintf(stdout,"0.5\n");
            } break;
            case 'b':
            {
              fprintf(stdout,"0.25\n");
            } break;
            case 'c':
            {
              fprintf(stdout,"0.10\n");
            } break;
            case 'd':
            {
              fprintf(stdout,"0.05\n");
            } break;
            case 'e':
            {
              fprintf(stdout,"0.025\n");
            } break;
            case 'f':
            {
              fprintf(stdout,"0.0125\n");
            } break;
            case 'g':
            {
              fprintf(stdout,"0.01\n");
            } break;
            default:
            {
              fprintf(stderr,"Invalid conductivity\n");
            } break;
          }
#endif
        }
        fprintf(stdout,"%i\n",around);
        fprintf(stdout,"%i\n",azimuthal);
	if(linear)
	{
		num_dof = (azimuthal-1)*around+2;
	}
	else
	{
		num_dof = (((azimuthal-1)*around+2)-2)*3+2;
	}
        fprintf(stdout,"%i\n",num_dof);
#if defined (ACTUAL)
        fprintf(stdout,"%i\n",source_rad);
#else
        fprintf(stdout,"%f\n",(double)(source_rad/10.0));
#endif
        fprintf(stdout,"%c\n",source_rad_dir);
        fprintf(stdout,"%c\n",source_dir);
      }
      else
      {
        fprintf(stderr,"Could not get other information\n");
      }
    }
    else
    {
      fprintf(stderr,"Could not get number of spheres\n");
    }
  }
  else
  {
    fprintf(stderr,"Invalid number of arguments\n");
  }
}
