#Example_538  Inflation, axial extension and torsion of an isotropic, homogeneous cylinder (analytic solution is available)
 
fem
fem define coordinates;r;cylanalyt;example #Define 3 GLOBAL CYLINDRICAL
#                               !  POLAR coordinates for an UNSYMMETRIC
#                               !  GEOMETRY, RADIAL INTERPOLATION in r.
#                               !  Written to file CYLIND.ipcoor.
fem define node;r;;example          #4 NODES, 3 COORDINATES, NO VERSION
#                               !  PROMPTING, 0 DERIVATIVES for all
#                               !  coordinates. Nodal coordinates (Xj)
#                               !  are (R,theta,Z): 1=(1,0,0);
#                               !  2=(1,0,1); 3=(1.5,0,0); 4=(1.5,0,1).
fem define base;r;;example          #Define 3 BASIS FUNCTIONS. Choose
#                               !  LAGRANGE/HERMITE for basis function 1
#             !  with 3 Xi COORDINATES, a LINEAR LAGRANGE interpolant
#             !  and 1 GAUSS POINT each in Xi(1) (circumferential) and
#             !  Xi(2) (axial) directions but 3 in Xi(3) (radial).
#             !  For basis function 2 (hydrostatic pressure), choose an
#             !  AUXILIARY BASIS with 5 AUXILIARY ELEMENT PARAMETERS,
#             !  PRESSURE BASIS with 3 Xi coordinates and the same
#             !  number of Gauss points as basis function 1. For all 5
#             !  parameters choose POLYNOMIAL DEGREE of 0 (ie constant)
#             !  in Xi1 and Xi2 directions. For parameters 1;2;3;4;5
#             !  choose POLYNOMIAL DEGREE 0;1;2;-1;-2 respectively
#             !  (0;1;2 denote a quadratic variation in the hydrostatic
#             !  pressure in Xi3 whilst -1;-2 denotes parameters for
#             !  Xi3=0;Xi3=1 face pressure bcs respectively.)  Basis
#             !  function 3 describes surfaces and thus has 2 Xi
#             !  COORDINATES with LINEAR LAGRANGE interpolant, and 3
#             !  Gauss points in Xi(1) and Xi(2) directions.
fem define element;r;;example       #1 ELEMENT with 3 Xj COORDINATES. BASIS
#                               !  FUNCTION 1 describes each coordinate.
#                               !  GLOBAL NODE # is 1,1,2,2,3,3,4,4.
fem define fibres;r;;example
fem define elements;r;;example fibre
fem define window;r;;example        #Define window dimensions in X,Y,Z
#                               !  directions as (min,max): (-2,2),
#                               !  (-2,2), (-1,2).
fem draw lines                  #Make line segments visible on window.
fem define equation;r;;example      #Defines equation the same as in the
#                               !  uniaxial cube extension problem.
fem define material;r;;example      #Defines a Mooney-Rivlin material as in
#                               !  the uniaxial cube extension problem.
fem define initial;r;;example       #BOUNDARY PRESSURE INCREMENTS will be
#                               !  entered and HYDROSTATIC PRESSURE will
#             !  be matched across elements with adjacent Xi3 faces
#             !  (none in this example). INITIAL DISPLACEMENTS are ALL
#             !  ZERO. For dep var 2 (theta-direction) fix nodes 1,3 and
#             !  ans set increments of 0.524 (30 deg) for nodes 2,4; for
#             !  dep var 3 (Z-direction), fix nodes 1,3 and apply 0.2
#             !  displacement to nodes 2,4. Pressure bcs are applied
#             !  via DEPENDENT VARIABLE/EQUATION 4. For ELEMENT 1 DO NOT
#             !  prescribe bcs for parameters 1,2,3; to apply a pressure
#             !  of magnitude 1.5 kPa on Xi3=0 face (inside) prescribe
#             !  an INCREMENT of 1.5 to AUXILIARY VARIABLE 4.  To apply
#             !  a pressure of magnitude 0 kPa on Xi(3)=1 face (outside
#             !  cylinder) prescribe an INCREMENT of 0.0 to AUXILIARY
#             !  VARIABLE 5 (note these param #'s correlate with the
#             !  basis description file).
fem define solve;r;;example         #Defines solution information.
fem solve step 1                #Solve the problem, (should converge
#                               !  in about 6 iterations).
fem draw lines def dotted       #Draw deformed mesh.
fem list elem tot
fem list elem deformed total
#              !Note volume is not conserved with quadratic transmural
#              !  hydrostatic pressure and r interpolation (I3 not equal
#              !  to 1).
fem list strain xi 3 points 3 ref  #List strain wrt reference coords at
#                                  !  3 pts in xi3 dirn (xi1=xi2=0.5).
fem list stress xi 3 points 3 ref  #List stress wrt reference coords at
#                                  !  3 pts in xi3 dirn (xi1=xi2=0.5).
fem list node solution
              # The radial stress at the first point (ng=1) is
              #   at the inner face where the stress should be close
              #   to the applied pressure (-1.5) but is quite different.
              #   At the third point (ng=3), at the outer face, the
              #   radial stress should be near zero but is again quite
              #   different from what is expected.
              #   Contrast the results at the second point (ng=2)
              #   and the deformed radii with the analytic solution.
