#Example_5521  Inflation and active contraction of an orthotropic prolate element

fem
fem define param;r;prol;example                 # 3D prolate spheroidal
fem define coordinate;r;profib;example          # 4 nodes of previous example_5512
fem define node;r;profib;example                # trilinear + quadratic hydr. pressure
fem define base;r;profib;example                # single axisymmetric element
fem define element;r;profib;example             # fibre angles of previous example_5512
fem define fibre;r;profib;example               # fibre elements
fem define element;r;profib;example fibre
fem define equation;r;profib;example            # 3D, finite elasticity
# 
# INFLATION
# 
fem define material;r;profib;example            # incomp; pole-zero law
fem define initial;r;profib;example             # Internal pressure of 4kPa        
fem define solve;r;profib;example               # Newton iterations
fem solve increment 0.2 iter 8                  # Gradually increment Pressure
fem solve increment 0.3 iter 11 
fem solve increment 0.3 iter 8
fem solve increment 0.1 iter 6
fem eval reac                                   # Inflated solution is converged OK! 
#
fem define window 
fem draw lines 
fem draw lines dot def 
refresh graphics
# 
# EJECTION 
# 
fem define material;r;profib_active;example     # incomp; pole-zero law + active fibre stress
fem define active;r;profib;example              # steady state calcium/length/tension
fem define solve;r;profib;example               # Newton iterations
fem solve increment 0                           # check current solution is converged
fem draw;add lines deformed dotted rgb=blue
refresh graphics


fem define active;r;profib_active;example       # Increase activation level  
fem solve increment 0 iterate 10                # Solve with new activation level but keep press const.
fem define initial;w;profib_endeject            # Save deformed configurations for end ejection 
fem draw;add lines deformed dotted rgb=blue
refresh graphics

