#Example 561:  Finite elasticity analysis of heart inflation with 8 prolate 
#              elements. Galerkin FEM equations solved using LU with parallel
#              computations of element stiffness matrices.
#
#IMPORTANT:
#This example requires 'proxies' on the alpha and/or a '.rhosts' file on the 
#SGI network so that the 'rsh' command will be able to spawn the remote
#processes automatically (see your system manager for these privileges).
#
fem define coordinates;r;parallel_proc;example #set up a finite elasticity
fem define nodes;r;;example                    #problem with 8 prolate elements
fem define bases;r;;example                    #undergoing inflation (see other
fem define element;r;;example                  #examples for details)
fem define fibre;r;;example                    
fem define element;r;;example fibre
fem define equation;r;;example
fem define material;r;;example
fem define initial;r;;example
fem define solve;r;;example       #set up solution procedure to use 
#                         !PARALLEL ELEMENT STIFFNESS COMPUTATIONS
#                         !on 2 hosts (ESU12 and ESV25). Use default CONNIDs
#                         !and PORT #s and SPAWN PROCESSES AUTOMATICALLY and
#                         !open the sockets after 20 secs 
#                         !(just to make sure that remote processes are set up)
fem solve incr 0.1 iter 2 #solve just 2 iterations to show how it works
fem def wind
fem draw line
fem draw line def dot
fem
