#Example 5c4


set num_threads 3;

fem define parameters;r;pressure_inflation;example
fem define coordinates;r;3d_Standard_RC;example reg 1
fem define bases;r;3CubicHermite_3x3x3Gauss_ArithMeanSE;example reg 1            # Geometry
fem define ;add bases;r;2CubicHermite_3x3Gauss_ArithMeanSE;example reg 1         # Faces
fem define ;add bases;r;3Linear-2PressAuxXi3_3x3x3Gauss;example reg 1            # Pressure
fem define ;add bases;r;2Linear_3x3Gauss;example reg 1                           # Faces
fem define nodes;r;wedge;example reg 1 
fem define elements;r;wedge;example reg 1
fem define fibres;r;wedge;example reg 1
fem define elements;r;wedge;example fibre reg 1

fem refine xi 1 at 0.3 element 1,2,3
fem refine xi 1 at 0.5 element 4,5,6

fem refine xi 2 at 0.3  
fem refine xi 2 at 0.5 element 10..18

fem refine xi 3 at 0.5 element 13


fem define equation;r;Incompressible_Finite_Elasticity;example reg 1
fem define material;r;Orthotropic_Incompressible;example reg 1
fem define active;r;active0_00;example reg 1

fem define initial;r;pressure_3CubicHermite_3linpres;example reg 1
#
#
#
#Solve 
#
fem define solve;r;newton;example reg 1
set out;steps_inflate on
$NAME1 = "wedge_def_00"
$NAME2 = "_active_0000"
$ITERS = 20
$TOL = 0.001

#
#increase pressure incrementally
#
for $PRESS ( 0..1 ) 
{

  if( $PRESS < 1 )
  {
    $FILENAME = "${NAME1}${PRESS}$NAME2"
    $INCREM = 0.0
  } else
  {
    $FILENAME = "${NAME1}${PRESS}$NAME2"
    $INCREM = 0.1
  }

  list assign 
  fem solve increment $INCREM iter $ITERS error $TOL
  fem export nodes;$FILENAME field as wedge
  fem export elements;$FILENAME field as wedge
  fem define initial;w;$FILENAME
}
set out off
