if (! defined $output) {
		$outputDir = "output-$ENV{'HOSTTYPE'}";
}
if (! defined $movie) {
    $movie = 0;
}
if (! defined $images) {
    $images = 0;
}

# Read in the undeformed geometry
gfx read node $outputDir."/wedge"
gfx read element $outputDir."/wedge"
# And the deformed geometry
gfx read node $outputDir."/deformed_0"
gfx read element $outputDir."/deformed"

gfx set vis axes off

if ($movie || $images) {
gfx create window 1 double_buffer
gfx modify window 1 image scene default light_model default
gfx modify window 1 image add_light default
gfx modify window 1 layout simple ortho_axes z -y eye_spacing 0.25 width 406 height 395
gfx modify window 1 set current_pane 1
gfx modify window 1 background colour 0 0 0 texture none
gfx modify window 1 view parallel eye_point 37.2642 -98.2068 115.901 interest_point 5.0605 -20.7686 52.492 up_vector 0.352806 0.676254 0.646691 view_angle 32.2933 near_clipping_plane 1.0514 far_clipping_plane 375.736 relative_viewport ndc_placement -1 1 2 2 viewport_coordinates 0 0 1 1
gfx modify window 1 overlay scene none
gfx modify window 1 set transform_tool current_pane 1 std_view_angle 40 normal_lines antialias 8 slow_transparency
} else {
gfx create window 1 double_buffer
gfx modify window 1 image scene default light_model default
gfx modify window 1 image add_light default
gfx modify window 1 layout orthographic ortho_axes z -y eye_spacing 0.25 width 576 height 562
gfx modify window 1 set current_pane 1
gfx modify window 1 background colour 0 0 0 texture none
gfx modify window 1 view parallel eye_point 37.2643 -98.2069 115.901 interest_point 5.0605 -20.7686 52.492 up_vector 0.352805 0.676254 0.646691 view_angle 32.2933 near_clipping_plane 1.0514 far_clipping_plane 375.736 relative_viewport ndc_placement -1 1 2 2 viewport_coordinates 0 0 1 1
gfx modify window 1 overlay scene none
gfx modify window 1 set current_pane 2
gfx modify window 1 background colour 0 0 0 texture none
gfx modify window 1 view parallel eye_point 54.0615 -25.2493 145.408 interest_point 5.0605 -20.7686 52.492 up_vector -0.601929 0.71678 0.352005 view_angle 32.2933 near_clipping_plane 1.0514 far_clipping_plane 375.736 relative_viewport ndc_placement -1 1 2 2 viewport_coordinates 0 0 1 1
gfx modify window 1 overlay scene none
gfx modify window 1 set current_pane 3
gfx modify window 1 background colour 0 0 0 texture none
gfx modify window 1 view parallel eye_point -63.1168 -93.9459 84.9179 interest_point 5.0605 -20.7686 52.492 up_vector 0.466053 -0.0426163 0.88373 view_angle 32.2933 near_clipping_plane 1.0514 far_clipping_plane 375.736 relative_viewport ndc_placement -1 1 2 2 viewport_coordinates 0 0 1 1
gfx modify window 1 overlay scene none
gfx modify window 1 set current_pane 4
gfx modify window 1 background colour 0 0 0 texture none
gfx modify window 1 view parallel eye_point 68.3475 -96.1312 15.4821 interest_point 5.0605 -20.7686 52.492 up_vector 0.466053 -0.0426163 0.88373 view_angle 32.2933 near_clipping_plane 1.0514 far_clipping_plane 375.736 relative_viewport ndc_placement -1 1 2 2 viewport_coordinates 0 0 1 1
gfx modify window 1 overlay scene none
gfx modify window 1 set transform_tool current_pane 1 std_view_angle 40 normal_lines no_antialias fast_transparency
}

gfx create material white diff 1.0 1.0 1.0 
gfx create material black diff 0.0 0.0 0.0 
gfx create material green diff 0.0 1.0 0.0 

##
## Use the deformed coordinates
##
gfx modify g_element wedge general clear circle_discretization 6 default_coordinate deformed element_discretization "10*10*10"

##
## Draw the deformed and undeformed lines
##
gfx set line_width 1
gfx modify g_element wedge lines coordinate default_coordinate material white
gfx modify g_element wedge lines material green

##
## Set-up and draw the deforming fibres
##
# F = dx/dX
gfx define field F coordinate_system rectangular_cartesian gradient coordinate coordinates field deformed
# F(transpose)
gfx define field F_transpose coordinate_system rectangular_cartesian transpose source_number_of_rows 3 field F
# The deforming fibre orientation field
gfx define field fibre_axes coordinate_system rectangular_cartesian fibre_axes coordinate coordinates fibre fibres
gfx define field fibre_axes2 coordinate_system rectangular_cartesian composite fibre_axes.1 fibre_axes.2 fibre_axes.3 fibre_axes.4 fibre_axes.5 fibre_axes.6 fibre_axes.7 fibre_axes.8 fibre_axes.9
gfx define field deformed_fibre_axes coordinate_system rectangular_cartesian matrix_multiply number_of_rows 3 fields fibre_axes2 F_transpose
gfx define field deformed_fibre_axis1 coordinate_system rectangular_cartesian composite deformed_fibre_axes.1 deformed_fibre_axes.2 deformed_fibre_axes.3
# The element points showing the deforming fibre orientation
gfx modify g_element wedge element_points glyph cylinder general size "0*0*0" centre 0.5,0,0 orientation deformed_fibre_axis1 scale_factors "4*1*1" use_elements cell_centres discretization "1*1*6" native_discretization NONE select_on material green selected_material default_selected

##
## Set-up and draw a representation of the principal strains
##
# C = F(transpose) . F
gfx define field C coordinate_system rectangular_cartesian matrix_multiply number_of_rows 3 fields F_transpose F
# 3D identity matrix
gfx define field identity2 coordinate_system rectangular_cartesian composite 1 0 0 0 1 0 0 0 1
# E = 0.5 (C - I)
gfx define field E2 coordinate_system rectangular_cartesian add fields C identity2 scale_factors 1 -1
gfx define field E coordinate_system rectangular_cartesian scale field E2 scale_factors 0.5 0.5 0.5 0.5 0.5 0.5 0.5 0.5 0.5
# Principal strains
gfx define field principal_strains coordinate_system rectangular_cartesian eigenvalues field E
gfx define field principal_strain1 coordinate_system rectangular_cartesian composite principal_strains.1
gfx define field principal_strain2 coordinate_system rectangular_cartesian composite principal_strains.2
gfx define field principal_strain3 coordinate_system rectangular_cartesian composite principal_strains.3
# and the corresponding vectors
gfx define field principal_strain_vectors coordinate_system rectangular_cartesian eigenvectors eigenvalues principal_strains
gfx define field deformed_principal_strain_vectors coordinate_system rectangular_cartesian matrix_multiply number_of_rows 3 fields principal_strain_vectors F_transpose
gfx define field deformed_principal_strain_vector1 coordinate_system rectangular_cartesian composite deformed_principal_strain_vectors.1 deformed_principal_strain_vectors.2 deformed_principal_strain_vectors.3
gfx define field deformed_principal_strain_vector2 coordinate_system rectangular_cartesian composite deformed_principal_strain_vectors.4 deformed_principal_strain_vectors.5 deformed_principal_strain_vectors.6
gfx define field deformed_principal_strain_vector3 coordinate_system rectangular_cartesian composite deformed_principal_strain_vectors.7 deformed_principal_strain_vectors.8 deformed_principal_strain_vectors.9
gfx define field norm_def_principal_strain_vector1 coordinate_system rectangular_cartesian normalise field deformed_principal_strain_vector1
gfx define field norm_def_principal_strain_vector2 coordinate_system rectangular_cartesian normalise field deformed_principal_strain_vector2
gfx define field norm_def_principal_strain_vector3 coordinate_system rectangular_cartesian normalise field deformed_principal_strain_vector3
# Create a spectrum for the strain
gfx create spectrum strain
gfx modify spectrum strain clear overwrite_colour
gfx modify spectrum strain linear reverse range 0 1 extend_above red colour_range 1 1 ambient diffuse component 1
gfx modify spectrum strain linear reverse range -1 0 extend_below blue colour_range 1 1 ambient diffuse component 1
gfx modify spectrum strain linear reverse range -1 0 extend_below green colour_range 0.5 0.5 ambient diffuse component 1
# Add some element points to show the principal strains
gfx modify g_element wedge element_points glyph mirror_cone general size "0*0*0" centre 0,0,0 orientation norm_def_principal_strain_vector1 variable_scale principal_strain1 scale_factors "10*0.4*0.4" use_elements cell_centres discretization "1*1*1" native_discretization NONE select_on material white data principal_strain1 spectrum strain selected_material default_selected
gfx modify g_element wedge element_points glyph mirror_cone general size "0*0*0" centre 0,0,0 orientation norm_def_principal_strain_vector2 variable_scale principal_strain2 scale_factors "10*0.4*0.4" use_elements cell_centres discretization "1*1*1" native_discretization NONE select_on material white data principal_strain2 spectrum strain selected_material default_selected
gfx modify g_element wedge element_points glyph mirror_cone general size "0*0*0" centre 0,0,0 orientation norm_def_principal_strain_vector3 variable_scale principal_strain3 scale_factors "10*0.4*0.4" use_elements cell_centres discretization "1*1*1" native_discretization NONE select_on material white data principal_strain3 spectrum strain selected_material default_selected

if ($movie) {
    gfx movie create movie.mv quicktime window 1;
    $counter = 0;
		for ($counter=0;$counter<=30;$counter+=0.5) {
				gfx read node $outputDir."/deformed_".$counter;
				gfx update window 1;
				gfx movie add_frame;
    }
    gfx movie end;
} elsif ($images) {
    $counter = 0;
		for ($counter=0;$counter<=30;$counter+=1.0) {
				print "Counter = $counter\n";
				gfx read node $outputDir."/deformed_".$counter;
				gfx update window 1;
				gfx print file $outputDir."/image_$counter.rgb" rgb window 1;
    }
} else {
#    gfx read node $outputDir."/deformed_0"
    $counter = 0;
    for ($counter=0;$counter<=30;$counter+=0.5) {
				gfx read node $outputDir."/deformed_".$counter;
				gfx update window 1;
    }
}

#quit
