#Material parameter fitting by least squares (fit c1 & c2 parameters)
#A one element membrane is solved for two loading conditions
#The deformed coords and corresponding forces are written to files
#These files are then read in as data for the parameter estimation.

fem de node;r;test;example      #4 nodes
fem de base;r;;example          #bilinear
fem de elem;r;;example          #1 element
fem de fibr;d
fem de elem;d fibre
fem de wind
fem dr line

fem de equa;r;;example          #finite elasticity membrane
fem de mate;r;;example          #Mooney-Rivlin c1=1, c2=0.2 both node based
fem de init;r;;example          #nodes 1,3 x_displ=0; nodes 1,2 y_displ=0
#                               !node 4 x_displ=0.1 y_disp=0.2
fem de solv;r;;example

fem solve step 1                
fem li node sol
fem dr line def rgb=blue 
fem de node;w;coord1 dep 1 nc 1 #write deformed coords to coord1.ipnode
fem de node;w;force1 dep 4 nc 1 #write reaction forces to force1.ipnode

fem solve step 1               
fem li node sol
fem dr line def rgb=blue 
fem de node;w;coord2 dep 1 nc 1 #write deformed coords to coord2.ipnode
fem de node;w;force2 dep 4 nc 1 #write boundary forces to force2.ipnode

fem de opt;r;test;example       #1 param only in fit
fem eval resid with 1,1,1,1,0.2,0.2,0.2,0.2 #correct values, so resids=0
#fem eval resid num_deriv       !gives RESJAC matrix (#resids x #params)

fem de field;r;test;example     #setup field variable for material param fit
fem de elem;r;example field

fem de fit;r;example material resid #define fit for material params to residuals
fem de node;r;coord1 dep 11 nc 1    #read in deformed coords to YP(ny,1)
fem de node;r;force1 dep 11 nc 2    #read in nodal forces to YP(ny+NYT,1)
fem de node;r;coord2 dep 12 nc 1    #read in deformed coords to YP(ny,2)
fem de node;r;force2 dep 12 nc 2    #read in nodal forces to YP(ny+NYT,2)

fem fit      #least-squares fit of material params to nodal residuals

fem list mate using solve #list original material parameters  (c1=1,c2=0.2)
fem list mate using fit   #list fitted material parameters (c1,c2 at 4 nodes)
fem
