#
# Sets up default colours and axes visualisation
#

gfx cre mat red      diff 1.0 0.0 0.0 spec 0.8 0.4 0.4 shin 1.0 alpha .9;
gfx cre mat dblue    diff 0.0 0.1 1.0 spec 0.4 0.4 0.5 shin 0.5;
gfx cre mat gold     diff 1.0 0.7 0.0 spec 0.5 0.5 0.5 ambi 1.0 0.7 0.0 shin 0.8;
gfx cre mat green    diff 0.0 1.0 0.0 alpha 0.9;

gfx create axes length 60 material green
gfx draw axes
gfx set vis axes on;

#
# Initial Model
#
gfx read node ${SPECIMEN}.${SURFACE}."_init";
gfx read elem ${SPECIMEN}.${SURFACE}."_init";
gfx mod g_elem ${SPECIMEN}.${SURFACE}."_init" surf mat gold;


#
# Model
#
gfx read node ${SPECIMEN}.${SURFACE};
gfx read elem ${SPECIMEN}.${SURFACE};
gfx mod g_elem ${SPECIMEN}.${SURFACE} surf mat dblue;

#
# Data points 
#
gfx read data ${SPECIMEN}.${SURFACE}."_data";
gfx mod g_elem ${SPECIMEN}.${SURFACE}."_data" data mat gold;
gfx mod g_elem ${SPECIMEN}.${SURFACE}."_data" data glyph line orient error mat green;



#
# Hides axes visualisation and opens window 1
#

gfx set vis axes off;
gfx cre win 1;
gfx mod win 1 image view;
gfx mod win 1 set slow;
gfx mod win 1 set pert;
gfx mod win 1 background colour 1 1 1 all;


#gfx set vis ${SPECIMEN}.${SURFACE}."_init" off;


