#
# Initial model geometry from MRP01
#
$MRP01_DIR="../../geometry/final/";
$DATA_DIR="./original_data/";

set directory current $MRP01_DIR;
read commands;MRP01;
set directory current "./";


#
# Add initial fibre & imbrication and sheet fields
#
fem define fibre;r;MRP01_initial from geometry;
fem define elem;r;MRP01 fibre;

fem group elements all_elements as ALL_ELEMENTS;


#
# Fit myocardial fibres
# 
fem define data;r;myo-corrected fibre;
fem change data coordinates cylinder to rectangular;
fem def xi;c close; 
fem change data fibres wrt_xi1;
fem change data fibres radians;
fem define fit;r;myo fibre;
fem fit;



#
# Fit epicardial fibres
#                       
#fem define data;r;epicardium_fibre_cyl_zero fibre; #For testing xi1 corrections
fem define data;r;$DATA_DIR."epicardium_fibre_cyl_uncorrected" fibre;
fem export data;epicardium_fibre_cyl_uncorrected as fibre_data;
#
fem change data fibres surface_norm;
fem define data;w;epicardium_fibre_cyl_corrected fibre degrees ;
fem export data;epicardium_fibre_cyl_corrected as fibre_data;
#
fem change data coordinates cylinder to rectangular;
fem define data;w;epicardium_fibre_rc_corrected fibre degrees; 
fem export data;epicardium_fibre_rc_corrected as fibre_data;
#
fem def xi;c closest_face faces EPI_FACES; 
fem change data fibres wrt_xi1;
fem define data;w;epicardium_fibre_cyl_corrected_xi1 fibre degrees; 
fem export data;epicardium_fibre_cyl_corrected_xi1 as fibre_data;
#
fem change data fibres radians
fem define data;w;epicardium_fibre_cyl_corrected_xi1_rads fibre radians; 
fem export data;epicardium_fibre_cyl_corrected_xi1_rads as fibre_data;
#
fem define fit;r;epi fibre faces EPI_FACES;
fem fit;                                                                       

                      
#
# Fit LV endocardial fibres
#                       
fem define data;r;$DATA_DIR."LVendo-fibres" fibre;
fem change data fibres surface_norm;
fem change data coordinates cylinder to rectangular;
fem def xi;c closest_face faces LV_FACES;
fem change data fibres wrt_xi1;
fem change data fibres radians;
fem define fit;r;lv_endo fibre faces LV_FACES;
fem fit;                          



#
# Fit RV endocardial fibres
# 
# Septal wall                      
#fem define data;r;$DATA_DIR."RVendo-septal_wall_cyl_uncorrected" fibre;
#fem change data coordinates cylinder to rectangular;
#fem def xi;c closest_face faces RV_SEPT_FACES;
#fem change data fibres wrt_xi1;
#fem change data fibres radians;
#fem define fit;r;rv_sept fibre faces RV_SEPT_FACES;
#fem fit;


# Free wall                      
fem group faces 119,123,198,202,205,209,213,217,238,243,322 as RV_FREE_FACES_upper;
fem define data;r;$DATA_DIR."RVendo-free_wall_cyl_uncorrected" fibre;
fem change data coordinates cylinder to rectangular;
fem def xi;c closest_face faces RV_FREE_FACES;
fem change data fibres wrt_xi1;
fem change data fibres radians;
#fem define fit;r;rv_free fibre faces RV_FREE_FACES;
fem define fit;r;rv_free fibre faces RV_FREE_FACES_upper;
fem fit;





#
# New model with fibres for MRP01
#
fem define fibre;w;MRP01;
fem export node;MRP01 as MRP01;
fem export elem;MRP01 as MRP01;







