
#
# Sets up default colours and axes visualisation
#

gfx cre mat red      diff 1.0 0.0 0.0 spec 0.8 0.4 0.4 shin 1.0 alpha .9
gfx cre mat dblue    diff 0.0 0.1 1.0 spec 0.4 0.4 0.5 shin 0.5 
gfx cre mat gold     diff 1.0 0.7 0.0 spec 0.5 0.5 0.5 ambi 1.0 0.7 0.0 shin 0.8
gfx cre mat green    diff 0.0 1.0 0.0 alpha 0.9






#
# Initial Model
#
gfx read node aortic_valve_init
gfx read elem aortic_valve_init
gfx modify g_element aortic_valve_init general clear circle_discretization 6 default_coordinate default_coordinate element_discretization "8*8*8" native_discretization none
gfx modify g_element aortic_valve_init lines select_on material gold selected_material default_selected


#
# Model
#
gfx read node aortic_valve
gfx read elem aortic_valve
gfx modify g_element aortic_valve general clear circle_discretization 6 default_coordinate default_coordinate element_discretization "8*8*8" native_discretization none
gfx modify g_element aortic_valve lines select_on material green selected_material default_selected
gfx modify g_element aortic_valve node_points glyph point general size "1*1*1" centre 0,0,0 label cmiss_number select_on material default selected_material default_selected

#
# Data points 
#
gfx read data aortic_valve_data
gfx modify g_element aortic_valve_data general clear circle_discretization 6 default_coordinate default_coordinate element_discretization "4*4*4" native_discretization none
gfx modify g_element aortic_valve_data lines select_on material default selected_material default_selected
gfx modify g_element aortic_valve_data data_points glyph cross general size "1*1*1" centre 0,0,0 select_on material green selected_material default_selected
gfx modify g_element aortic_valve_data data_points glyph line general size "0*0*0" centre 0,0,0 orientation error scale_factors "1*1*1" select_on material dblue selected_material default_selected



#
# Hides axes visualisation and opens window 1
#


gfx create window 1 double_buffer
gfx modify window 1 image scene default light_model default
gfx modify window 1 image add_light default
gfx modify window 1 layout simple ortho_axes z -y eye_spacing 0.25 width 642 height 704
gfx modify window 1 set current_pane 1
gfx modify window 1 background colour 1 1 1 texture none
gfx modify window 1 view parallel eye_point -19.1043 -1.89634 -25.9844 interest_point 1.53565 5.79978 31.9727 up_vector 0.650512 0.687416 -0.322945 view_angle 36.8141 near_clipping_plane 0.620021 far_clipping_plane 221.574 relative_viewport ndc_placement -1 1 2 2 viewport_coordinates 0 0 1 1
gfx modify window 1 overlay scene none
gfx modify window 1 set transform_tool current_pane 1 std_view_angle 40 normal_lines no_antialias fast_transparency


# commands for thesis pic
gfx modify g_element aortic_valve general clear circle_discretization 6 default_coordinate default_coordinate element_discretization "8*8*8" native_discretization none
gfx modify g_element aortic_valve lines select_on material default selected_material default_selected
gfx modify g_element aortic_valve node_points glyph sphere_hires general size "0.5*0.5*0.5" centre 0,0,0 select_on material default selected_material default_selected


gfx modify g_element aortic_valve_data general clear circle_discretization 6 default_coordinate default_coordinate element_discretization "4*4*4" native_discretization none
gfx modify g_element aortic_valve_data lines select_on material default selected_material default_selected
gfx modify g_element aortic_valve_data data_points glyph cross general size "0.5*0.5*0.5" centre 0,0,0 select_on material dblue selected_material default_selected
gfx modify g_element aortic_valve_data data_points glyph line general size "0*0*0" centre 0,0,0 orientation error scale_factors "1*1*1" select_on material red selected_material default_selected


gfx set vis aortic_valve_init off

gfx set line_width 3
gfx modify window 1 set antialias 8 


gfx print window 1 width 2048 height 2048 rgb file aortic_valve.rgb 

quit
