#
# Initial model geometry from MRP01
#
$MRP01_GEOM_DIR="../../geometry/final";
$MRP01_FIBR_DIR="../../fibres/new_face_fitting_method/";

set directory current $MRP01_GEOM_DIR;
read commands;MRP01;
set directory current "./";


fem define fibre;r;$MRP01_FIBR_DIR."MRP01";
fem define elem;r;$MRP01_FIBR_DIR."MRP01" fibre;


fem update field from geometry;   
#
fem export node;MRP01 as MRP01;
fem export elem;MRP01 as MRP01;

#
#
# First fit
#
fem define data;r;sheet_data_geom_epi_reduced;
fem change data coordinates cylinder to rectangular
fem change data rotate by -13,0,0 about 0,0,0 axis 0,0,1;   
fem de xi;c closest_face faces EPI_FACES; 
fem list data error;
fem export data;sheet_data_geom_epi as sheet_data_geom_epi error offset 1000;
fem de fit;r;fit_epi geom faces EPI_FACES;
fem fit;
fem update node fit
#
fem define data;r;sheet_data_geom_lv_endo;
fem change data coordinates cylinder to rectangular
fem change data rotate by -13,0,0 about 0,0,0 axis 0,0,1;   
fem de xi;c closest_face faces LV_FACES; 
fem list data error;
fem export data;sheet_data_geom_lv_endo as sheet_data_geom_lv_endo error offset 2000;
fem de fit;r;fit_lv geom faces LV_FACES;
fem fit;
fem update node fit
#
fem define data;r;sheet_data_geom_rv_free;
fem change data coordinates cylinder to rectangular
fem change data rotate by -13,0,0 about 0,0,0 axis 0,0,1; 
fem de xi;c closest_face faces RV_FREE_FACES; 
fem list data error;
fem export data;sheet_data_geom_rv_free as sheet_data_geom_rv_free error offset 3000;
fem de fit;r;fit_rv_free geom faces RV_FREE_FACES;
fem fit;
fem update node fit
#  
fem define data;r;sheet_data_geom_rv_sept;
fem change data coordinates cylinder to rectangular
fem change data rotate by -13,0,0 about 0,0,0 axis 0,0,1;  
fem de xi;c closest_face faces RV_SEPT_FACES; 
fem list data error;
fem export data;sheet_data_geom_rv_sept as sheet_data_geom_rv_sept error offset 4000;
fem de fit;r;fit_rv_sept geom faces RV_SEPT_FACES;
fem fit;
fem update node fit




#
# New model geometry for MRP02
#
fem export node;MRP02 as MRP02;
fem export elem;MRP02 as MRP02;



#
# Sheet angle data
#
# Export individually
fem define data;r;q108 sheet; 
fem change data coordinates cylinder to rectangular;
fem change data rotate by -13,0,0 about 0,0,0 axis 0,0,1;   
fem change data translate by 0,0,-16;   
fem export data;q108 as q108 offset 10000;
#
fem define data;r;q12 sheet; 
fem change data coordinates cylinder to rectangular;
fem change data rotate by -13,0,0 about 0,0,0 axis 0,0,1;   
fem change data translate by 0,0,-16;   
fem export data;q12 as q12 offset 20000;
#
fem define data;r;q120 sheet; 
fem change data coordinates cylinder to rectangular;
fem change data rotate by -13,0,0 about 0,0,0 axis 0,0,1;   
fem change data translate by 0,0,-16;   
fem export data;q120 as q120 offset 30000;
#
fem define data;r;q132 sheet; 
fem change data coordinates cylinder to rectangular;
fem change data rotate by -13,0,0 about 0,0,0 axis 0,0,1;   
fem change data translate by 0,0,-16;   
fem export data;q132 as q132 offset 40000;
#
fem define data;r;q144 sheet; 
fem change data coordinates cylinder to rectangular;
fem change data rotate by -13,0,0 about 0,0,0 axis 0,0,1;   
fem change data translate by 0,0,-16;   
fem export data;q144 as q144 offset 50000;
#
fem define data;r;q156 sheet; 
fem change data coordinates cylinder to rectangular;
fem change data rotate by -13,0,0 about 0,0,0 axis 0,0,1;   
fem change data translate by 0,0,-16;   
fem export data;q156 as q156 offset 60000;
#
fem define data;r;q168 sheet; 
fem change data coordinates cylinder to rectangular;
fem change data rotate by -13,0,0 about 0,0,0 axis 0,0,1;   
fem change data translate by 0,0,-16;   
fem export data;q168 as q168 offset 70000;
#
fem define data;r;q180 sheet; 
fem change data coordinates cylinder to rectangular;
fem change data rotate by -13,0,0 about 0,0,0 axis 0,0,1;   
fem change data translate by 0,0,-16;   
fem export data;q180 as q180 offset 80000;
#
fem define data;r;q192 sheet; 
fem change data coordinates cylinder to rectangular;
fem change data rotate by -13,0,0 about 0,0,0 axis 0,0,1;   
fem change data translate by 0,0,-16;   
fem export data;q192 as q192 offset 90000;
#
fem define data;r;q204 sheet; 
fem change data coordi sheetnates cylinder to rectangular;
fem change data rotate by -13,0,0 about 0,0,0 axis 0,0,1;   
fem change data translate by 0,0,-16;   
fem export data;q204 as q204 offset 100000;
#
fem define data;r;q216 sheet; 
fem change data coordinates cylinder to rectangular;
fem change data rotate by -13,0,0 about 0,0,0 axis 0,0,1;   
fem change data translate by 0,0,-16;   
fem export data;q216 as q216 offset 110000;
#
fem define data;r;q228 sheet; 
fem change data coordinates cylinder to rectangular;
fem change data rotate by -13,0,0 about 0,0,0 axis 0,0,1;   
fem change data translate by 0,0,-16;   
fem export data;q228 as q228 offset 120000;
#
fem define data;r;q24 sheet; 
fem change data coordinates cylinder to rectangular;
fem change data rotate by -13,0,0 about 0,0,0 axis 0,0,1;   
fem change data translate by 0,0,-16;   
fem export data;q24 as q24 offset 130000;
#
fem define data;r;q240 sheet; 
fem change data coordinates cylinder to rectangular;
fem change data rotate by -13,0,0 about 0,0,0 axis 0,0,1;   
fem change data translate by 0,0,-16;   
fem export data;q240 as q240 offset 140000;
#
fem define data;r;q252 sheet; 
fem change data coordinates cylinder to rectangular
fem change data rotate by -13,0,0 about 0,0,0 axis 0,0,1;   
fem change data translate by 0,0,-16;   
fem export data;q252 as q252 offset 150000;
#
fem define data;r;q264 sheet; 
fem change data coordinates cylinder to rectangular;
fem change data rotate by -13,0,0 about 0,0,0 axis 0,0,1;   
fem change data translate by 0,0,-16;   
fem export data;q264 as q264 offset 160000;
#
fem define data;r;q288 sheet; 
fem change data coordinates cylinder to rectangular;
fem change data rotate by -13,0,0 about 0,0,0 axis 0,0,1;   
fem change data translate by 0,0,-16;   
fem export data;q288 as q288 offset 170000;
#
fem define data;r;q300 sheet; 
fem change data coordinates cylinder to rectangular;
fem change data rotate by -13,0,0 about 0,0,0 axis 0,0,1;   
fem change data translate by 0,0,-16;   
fem export data;q300 as q300 offset 180000;
#
fem define data;r;q312 sheet; 
fem change data coordinates cylinder to rectangular;
fem change data rotate by -13,0,0 about 0,0,0 axis 0,0,1;   
fem change data translate by 0,0,-16;   
fem export data;q312 as q312 offset 190000;
#
fem define data;r;q324 sheet; 
fem change data coordinates cylinder to rectangular;
fem change data rotate by -13,0,0 about 0,0,0 axis 0,0,1;   
fem change data translate by 0,0,-16;   
fem export data;q324 as q324 offset 200000;
#
fem define data;r;q336 sheet; 
fem change data coordinates cylinder to rectangular;
fem change data rotate by -13,0,0 about 0,0,0 axis 0,0,1;   
fem change data translate by 0,0,-16;   
fem export data;q336 as q336 offset 210000;
#
fem define data;r;q348 sheet; 
fem change data coordinates cylinder to rectangular;
fem change data rotate by -13,0,0 about 0,0,0 axis 0,0,1;   
fem change data translate by 0,0,-16;   
fem export data;q348 as q348 offset 220000;
#
fem define data;r;q36 sheet; 
fem change data coordinates cylinder to rectangular;
fem change data rotate by -13,0,0 about 0,0,0 axis 0,0,1;   
fem change data translate by 0,0,-16;   
fem export data;q36 as q36 offset 230000;
#
fem define data;r;q360 sheet; 
fem change data coordinates cylinder to rectangular;
fem change data rotate by -13,0,0 about 0,0,0 axis 0,0,1;   
fem change data translate by 0,0,-16;   
fem export data;q360 as q360 offset 240000;
#
fem define data;r;q48 sheet; 
fem change data coordinates cylinder to rectangular
fem change data rotate by -13,0,0 about 0,0,0 axis 0,0,1;   
fem change data translate by 0,0,-16;   
fem export data;q48 as q48 offset 250000;
#
fem define data;r;q60 sheet;
fem change data coordinates cylinder to rectangular;
fem change data rotate by -13,0,0 about 0,0,0 axis 0,0,1;   
fem change data translate by 0,0,-16;   
fem export data;q60 as q60 offset 260000;
#
fem define data;r;q72 sheet;
fem change data coordinates cylinder to rectangular;
fem change data rotate by -13,0,0 about 0,0,0 axis 0,0,1;   
fem change data translate by 0,0,-16;   
fem export data;q72 as q72 offset 270000;
#
fem define data;r;q84 sheet; 
fem change data coordinates cylinder to rectangular;
fem change data rotate by -13,0,0 about 0,0,0 axis 0,0,1;   
fem change data translate by 0,0,-16;   
fem export data;q84 as q84 offset 280000;
#
fem define data;r;q96 sheet; 
fem change data coordinates cylinder to rectangular;
fem change data rotate by -13,0,0 about 0,0,0 axis 0,0,1;   
fem change data translate by 0,0,-16;   
fem export data;q96 as q96 offset 290000;


# or as one
fem define data;r;sheet_angle_data_combined sheet degrees; 
#fem define data;r;test sheet degrees; 
#fem define data;r;sheet_angle_data_combined-0 sheet degrees; 
fem change data coordinates cylinder to rectangular;
fem change data rotate by -13,0,0 about 0,0,0 axis 0,0,1;   
fem change data translate by 0,0,-16;   
fem export data;MRP02_sheet_data as MRP02_sheet_data;


#Xi locations of data in fitted model
fem de xi;c close; 
fem def xi;w;MRP02_sheet_data;

#Correct sheet angles
fem define data;c sheet;
fem define data;w;MRP02_sheet_data_corrected sheet degrees;
#fem define data;w;MRP02_sheet_data_corrected-0 sheet degrees;
#fem define data;w;test_corrected sheet degrees;





