
    fem list elements deformed total cavity_volume region $LV_CAVITY; # Defines and sets the var $LV_CAVITY_VOLUME
    fem list elements deformed total cavity_volume region $RV_CAVITY; # Defines and sets the var $RV_CAVITY_VOLUME
    print "\nLV cavity volume = ${LV_CAVITY_VOLUME}\n";
    print "RV cavity volume = ${RV_CAVITY_VOLUME}\n\n";
    $SYSTOLIC_LV_CAVITY_VOLUME = ${LV_CAVITY_VOLUME};
    $SYSTOLIC_RV_CAVITY_VOLUME = ${RV_CAVITY_VOLUME};
    print "\nSystolic LV cavity volume = ", $SYSTOLIC_LV_CAVITY_VOLUME, "\n";
    print "Systolic RV cavity volume = ", $SYSTOLIC_RV_CAVITY_VOLUME, "\n\n";

    $CA=$CA-1;
    MySubs::changeCalcium($CA/100);
    fem define active;r;${example}."calcium0xx" region $WALL;
    #fem define active;r;${example}.${NAME1}.${CA} region $WALL;
    fem solve increment 0.0 iter 5 error 0.1;
    $FILE = "fullheart_def_ivr_active_".$CA;
    fem define initial;w;${OUTPUT_DIR}.${FILE} region $WALL
    

    $CA=$CA-1;
    MySubs::changeCalcium($CA/100);
    fem define active;r;${example}."calcium0xx" region $WALL;
    #fem define active;r;${example}.${NAME1}.${CA} region $WALL;
    fem solve increment 0.0 iter 5 error 0.1;
    $FILE = "fullheart_def_ivr_active_".$CA;
    fem define initial;w;${OUTPUT_DIR}.${FILE} region $WALL

    $CA=$CA-1;
    $PendIVR = 3;
    $ITER = 10;
    $ERROR_TOLERANCE = 0.01;
    #
    $SOLVEAGAIN = 0;
    while (($LV_PRESS > $PendIVR ) || ($SOLVEAGAIN))
    {
        print "\033[0;30;43m                    Calcium Level = ${CA}                         \033[0m\n"; 
        #
        MySubs::changeCalcium($CA/100);
        fem define active;r;${example}."calcium0xx" region $WALL;
        #fem define active;r;${example}.${NAME1}.${CA} region $WALL;
        fem solve increment 0.0 iter $ITER  error $ERROR_TOLERANCE;
        $FILE = "fullheart_def_ivr_active_".$CA;
        fem define initial;w;${OUTPUT_DIR}.${FILE} region $WALL
        #
  $name = "heartIVRCalcium_".${CA};
  $file = $output.$name
  fem export nodes;$file field as $name offset 0
  fem export elements;$file field as $name offset_elem 0
  $name = "heartIVRCalciumStress_".${CA}; 
  $file = $output.$name
  fem update gauss stress total Cauchy reg $WALL
  #fem update gauss stress total_no_hydro Piola reg $WALL
  fem export gauss;$file yg as gauss_stress offset 0 reg $WALL
  $name = "heartIVCRalciumStrain_".${CA};
  $file = $output.$name
  fem update gauss strain fibre extension_ratios reg $WALL
  fem export gauss;$file yg as gauss_strain reg $WALL
        #
        fem list elements deformed total cavity_volume region $LV_CAVITY;
        fem list elements deformed total cavity_volume region $RV_CAVITY; 
        print "\nLV cavity volume = ${LV_CAVITY_VOLUME}\n";
        print "RV cavity volume = ${RV_CAVITY_VOLUME}\n\n";
        print "LV pressure: $LV_PRESS kPa\n";
        print "RV pressure: $RV_PRESS kPa\n\n";
        #
        if ($LV_CAVITY_VOLUME > ($SYSTOLIC_LV_CAVITY_VOLUME+$SYSTOLIC_LV_CAVITY_VOLUME*0.015) )
        {
            $INCREM = -0.2;
	    fem update pressure boundary elements LV_FREE_WALL auxillary 1 increment $INCREM;
	    fem update pressure boundary elements SEPTUM auxillary 1 increment $INCREM;
            $LV_PRESS = $LV_PRESS+$INCREM;
            print "\nIncreasing LV cavity pressure by $INCREM to $LV_PRESS kPa\n\n";
            $SOLVEAGAIN = 1;
        } elsif ($RV_CAVITY_VOLUME > ($SYSTOLIC_RV_CAVITY_VOLUME+$SYSTOLIC_RV_CAVITY_VOLUME*0.015) )
        {
            $INCREM = -0.2;
	    fem update pressure boundary elements SEPTUM auxillary 2 increment $INCREM;
	    fem update pressure boundary elements RV_FREE_WALL auxillary 1 increment $INCREM;
            $RV_PRESS = $RV_PRESS+$INCREM*0.2;
            print "\nIncreasing RV cavity pressure by $INCREM to $RV_PRESS kPa\n\n";
            $SOLVEAGAIN = 1;
        } else {
            $CA=$CA-1;
            $SOLVEAGAIN = 0;
        }
        #
    }
    #
    print "Total LV cavity pressure = $LV_PRESS\n";
    print "Total RV cavity pressure = $RV_PRESS\n";
    print "End-diastolic LV cavity volume = ${SYSTOLIC_LV_CAVITY_VOLUME}\n";
    print "End-isovolumic contraction LV cavity volume = ${LV_CAVITY_VOLUME}\n\n";
    print "End-diastolic RV cavity volume = ${SYSTOLIC_RV_CAVITY_VOLUME}\n";
    print "End-isovolumic contraction RV cavity volume = ${RV_CAVITY_VOLUME}\n\n";
    #

   
  
