$output = "output/bob";

gfx read node $output/wedge;
gfx read elem $output/wedge;
gfx read elem $output/potential_0;

#Window Commands
#===============
gfx create window 1 double_buffer
gfx modify window 1 image scene default light_model default
gfx modify window 1 image add_light default
gfx modify window 1 layout simple ortho_axes z -y eye_spacing 0.25 width 512 height 281
gfx modify window 1 set current_pane 1
gfx modify window 1 background colour 0 0 0 texture none
gfx modify window 1 view parallel eye_point -8.6942 82.533 66.3264 interest_point 5.0605 -20.7696 52.4924 up_vector 0.268127 -0.0927137 0.958912 view_angle 21.5849 near_clipping_plane 1.05128 far_clipping_plane 375.693 relative_viewport ndc_placement -1 1 2 2 viewport_coordinates 0 0 1 1
gfx modify window 1 overlay scene none
gfx modify window 1 set transform_tool current_pane 1 std_view_angle 40 normal_lines no_antialias fast_transparency

gfx set visibility axes off;

#Material Commands
#=================
gfx create material default ambient 1 1 1 diffuse 1 1 1 emission 0 0 0 specular 0 0 0 alpha 1 shininess 0;
gfx create material isosurface ambient 0.5 0.51 1 diffuse 0.5 0.5 1 emission 0.1 0.1 0.1 specular 0.1 0.1 0.1 alpha 1 shininess 0.5;

#Spectrum Commands
#=================
gfx modify spectrum default clear overwrite_colour
gfx modify spectrum default linear reverse range -85 30 extend_above extend_below rainbow colour_range 0 1 ambient diffuse component 1

#Drawing Commands
#================
gfx modify g_element wedge general clear circle_discretization 6 default_coordinate default_coordinate element_discretization "4*4*4" native_discretization potential
gfx modify g_element wedge surfaces select_on material default data potential spectrum default selected_material default_selected render_shaded
gfx modify g_element wedge cylinders constant_radius 0.1 select_on material default selected_material default_selected



#Read in next time steps
#=======================

if (! defined $movie) {
	$movie = 0;
}

gfx update window 1;

$tend = 10;

if ($movie) {
	gfx movie create movie.mv quicktime window 1;
	$tend = 500;
}

for $time (0..$tend) {
		print "Time = $time\n";
		gfx read element $output/potential_$time;
		gfx update window 1;
		if ($movie) {
			gfx movie add_frame;
		}
}

if ($movie) {
	gfx movie end;
}

