#Define region numbers

# Command updated by fixcom.sh on Wed Aug 23 17:50:03 NZT 2000
# Old command: assign variable INNER 1
$INNER = 1


# Command updated by fixcom.sh on Wed Aug 23 17:50:03 NZT 2000
# Old command: assign variable LLUNG 2
$LLUNG = 2


# Command updated by fixcom.sh on Wed Aug 23 17:50:03 NZT 2000
# Old command: assign variable RLUNG 3
$RLUNG = 3


# Command updated by fixcom.sh on Wed Aug 23 17:50:03 NZT 2000
# Old command: assign variable OUTER 4
$OUTER = 4


# Command updated by fixcom.sh on Wed Aug 23 17:50:03 NZT 2000
# Old command: assign variable HEART 5
$HEART = 5


#Define problem types

# Command updated by fixcom.sh on Wed Aug 23 17:50:03 NZT 2000
# Old command: assign variable GLAPLACE 1
$GLAPLACE = 1


# Command updated by fixcom.sh on Wed Aug 23 17:50:03 NZT 2000
# Old command: assign variable TMEMBRNE 2
$TMEMBRNE = 2


# Command updated by fixcom.sh on Wed Aug 23 17:50:03 NZT 2000
# Old command: assign variable EXTCELLR 3
$EXTCELLR = 3


# Command updated by fixcom.sh on Wed Aug 23 17:50:03 NZT 2000
# Old command: assign variable EXUPDATE 4
$EXUPDATE = 4


#Define problem parameter set
fem define para;r;torsoslice;example


#Define problem geometry
fem define regi;r;torsoslice;example
fem define node;r;hrefx2;example reg all
fem define base;r;torsoslice;example
fem define elem;r;hrefx2;example reg all
fem define fibr;r;heart;example reg $HEART
fem define elem;r;heart;example fibre reg $HEART

#Define finite difference grid
fem define grid;r;heart;example reg $HEART
fem update grid geometry reg $HEART
fem update grid metric reg $HEART
fem group grid external as boundary reg 5

#Define governing equations
fem define equa;r;inner;example reg $INNER class $GLAPLACE lock
fem define equa;r;llung;example reg $LLUNG class $GLAPLACE
fem define equa;r;rlung;example reg $RLUNG class $GLAPLACE
fem define equa;r;outer;example reg $OUTER class $GLAPLACE
fem define equa;r;heart;example reg $HEART class $TMEMBRNE,$EXTCELLR,$EXUPDATE lock

#Define material parameters
fem define mate;r;inner;example reg $INNER class $GLAPLACE
fem define mate;r;llung;example reg $LLUNG class $GLAPLACE
fem define mate;r;rlung;example reg $RLUNG class $GLAPLACE
fem define mate;r;outer;example reg $OUTER class $GLAPLACE
fem define mate;r;heart;example reg $HEART class $TMEMBRNE
fem define cell;r;heart;example reg $HEART class $TMEMBRNE
fem update grid material reg $HEART class $TMEMBRNE

#Define initial conditions
fem define init;r;heart;example reg $HEART class $TMEMBRNE,$EXTCELLR
fem define init;r;inner;example reg $INNER class $GLAPLACE
fem define init;r;outer;example reg $OUTER class $GLAPLACE

#Define region coupling
fem define coup;r;torsoslice;example

#Define solution parametres
fem define solv;r;heart_t;example reg $HEART class $TMEMBRNE
fem define solv;r;heart_e;example reg $HEART class $EXTCELLR
fem define solv;r;heart_u;example reg $HEART class $EXUPDATE
fem define solv;r;torsoslice;example coupled reg $INNER,$LLUNG,$RLUNG,$OUTER class $GLAPLACE

#Solve the activation problem
fem solve to 7 reg $HEART class $TMEMBRNE,$EXTCELLR,$EXUPDATE
fem update node potential reg $INNER,$HEART

#Solve the laplace problem
fem solve coupled class $GLAPLACE reg $INNER,$LLUNG,$RLUNG,$OUTER
fem update node potential reg $INNER,$HEART check

#Iterate to match the epicardial potentials & flux

# Command updated by fixcom.sh on Wed Aug 23 17:50:03 NZT 2000
# Old command: DO A=1..4
for $A ( 1..4 ) 
{

fem solve iterate 1 reg $HEART,$INNER class $TMEMBRNE,$EXTCELLR,$EXUPDATE,$GLAPLACE
fem update node potential reg $INNER,$HEART
fem solve coupled class $GLAPLACE reg $INNER,$LLUNG,$RLUNG,$OUTER
fem update node potential reg $INNER,$HEART check

# Command updated by fixcom.sh on Wed Aug 23 17:50:03 NZT 2000
# Old command: ENDDO
}



#Display the results
fem define wind;c
fem draw field grid 1 zmin=-22 zmax=1 noscale reg $HEART class $EXTCELLR
fem draw field zmin=-22 zmax=1 noscale reg $LLUNG class $GLAPLACE
fem draw field zmin=-22 zmax=1 noscale reg $RLUNG class $GLAPLACE
fem draw field zmin=-22 zmax=1 noscale reg $OUTER class $GLAPLACE
