!
! Parameters.Inc
! 
! Contains all parameter declarations for CMISS.  If this file
! is in a local directory, then change the logical cmiss$parameters 
! to point to that directory.
!

C#### NAMX is max# auxiliary parameters
C###  NBMX     "   basis functions
C###  NCMX     "   #equations for a given dependent var
C###  NDMX     "   data points
C###  NEMX     "   elements
C###  NE_R_MX is " elements in a region
C###  NFMX     "   global face segments
C###  NGMX     "   Gauss points per element
C###  NHMX     "   dependent variables
C###  NIMX     "   local Xi-coordinates
C###  NJMX     "   global reference coordinates
C###  NKMX     "   derivatives per variable
C###  NLMX     "   global line segments
C###  NL_R_MX is " lines in a region
C###  NMMX     "   material parameters
C###  NNMX     "   element nodes
C###  NOMX     "   degrees of freedom
C###  NPMX     "   global nodes
C###  NP_R_MX is " global nodes in a region
C###  NQMX     "   global grid points
C###  NRMX     "   regions & contours per elem & vari segs
C###  NSMX     "   element dofs per variable (<=NNMX*NKMX)
C###  NTMX     "   eigenvalues
C###  NUMX     "   derivative terms up to 2nd order
C###  NVMX     "   # of versions of a particular value.
C###  NWMX     "   workstations for segment arrays
C###  NXMX     "   the number of problem types
C###  NYMX     "   mesh dofs
C###  NY_R_MX is " mesh dofs in a region
C###  NZMX     "   coeff.s in 1D global stiffness vector
C###  NZ_arrayname_MX nz dimension of arrayname              
C###  NZ_MINOS  "  size of the minos sparse arrays
C###  NBFMX     "  basis function families
C###  NCOMX     "  num of non-lin constraint for opti probs
C###  NCYMX     "  size of complex arrays
C###  NDEMX     "  data points in one element
C###  NIQMX     "  variables per grid point 
C###  NIYMX     "  variables per mesh dof
C###  NLCMX     "  num of lin constraints for opti probs
C###  NOPMX     "  optimisation variables
C###  NORMX     "  size of fractal tree order arrays
C###  NOYMX     "  solution dofs attached to one mesh dof
C###  NOOPMX    "  optimisation or solution variables
C###  NPDMX     "  domain nodes for BE problems
C###  NPTMX     "  number of potential values
C###  NRCMX     "  number of rows and columns (s.b. 2)
C###  NREMX     "  residuals for optimization problems
C###  NYOMX     "  mesh dofs attached to one solution dof
C###  NYROWMX   "  rows in a problem
C###  NIMAGEMX  "  image cell array dimension
C###  NY_TRANSFER_MX  is maximum size of the transfer matrix
C###  NZ_ITERATIVE_MX size of iterative solver work array
C###  N_ITERATIVE_MX  second dimension of iterative solver
C###                  arrays (=num orthogonalisations+4 for
C###                  GMRES problems)
C###
C###  USE_BEM       is 1 if bem is to be used, 0 if not
C###  USE_DATA      is 1 if data is to be used, 0 if not
C###  USE_GRAPHICS  is 1 if graphics is to be used, 0 if not
C###  USE_GRID      is 1 if collocation grids are to be used, 0 if not
C###  USE_ITERATIVE is 1 if iterative solvers are to be used, 0 if not
C###  USE_LUNG      is 1 if lung problems are to be used, 0 if not
C###  USE_MINOS     is 1 if minos is to be used, 0 if not
C###  USE_NLSTRIPE  is 1 if non-lin stripe fit is to be used, 0 if not
C###  USE_NONLIN    is 1 if non-linear problems are to be used, 0 if not
C###  USE_NPSOL     is 1 if npsol is to be used, 0 if not 
C###  USE_SPARSE    is 1 if sparse arrays are to be used, 0 if not 
C###  USE_TRANSFER  is 1 if a transfer matrix is to be used/calculated
C###
C****
C###  Note: NHMX must be equal to NJMX for problems where the dependent
C###        variable array carries deformed coordinates.
C###  Note: NZMX must be > NOMX^2 and NYMX^2 for some problems and 
C###        large enough to take the fill in during sparse matrix 
C###        solution in others

      INTEGER NAMX,NAYMX,NBFMX,NBMX,NCMX,NCOMX,NDMX,NDEMX,
     '  NEMX,NEFMX,NE_R_MX,NEQMX,NFMX,NGMX,NHMX,NIMX,NIQMX,
     '  NISC_GDMX,NISC_GKMX,NISC_GKKMX,NISC2_GKKMX,NISC_GQMX,
     '  NISR_GDMX,NISR_GKMX,NISR_GKKMX,NISR2_GKKMX,NISR_GQMX,
     '  NIYMX,
     '  NJMX,NKMX,NLMX,NLISTMX,NL_R_MX,NMMX,NNMX,NOMX,NOPMX,NOOPMX,
     '  NORMX,NOYMX,NPMX,NPDMX,NP_R_MX,NPTMX,NQMX,NRMX,NRCMX,NREMX,
     '  NSMX,NTMX,NUMX,NVMX,NWMX,NXMX,NYMX,NYCMX,NYOMX,NY_R_MX,
     '  NYROWMX,NZMX,NZ_FNY_MX,NZ_GD_MX,NZ_GK_MX,NZ_GKK_MX,
     '  NZ_GM_MX,NZ_GMM_MX,NZ_GQ_MX,NZ_ITERATIVE_MX,N_ITERATIVE_MX,
     '  NZ_NZNY_MX,NLCMX,NMINWK,NZ_MINOS,NIMAGEMX,NY_TRANSFER_MX,
     '  USE_BEM,USE_DATA,USE_ITERATIVE,USE_GRAPHICS,USE_GRID,USE_LUNG,
     '	USE_MINOS,USE_NLSTRIPE,USE_NONLIN,USE_NPSOL,USE_SPARSE,
     '	USE_TRANSFER
      PARAMETER
     ' (NAMX=2,          NBMX=45,      NBFMX=16,
     '  NCMX=2,          NCOMX=1,      NDMX=1,
     '  NDEMX=1,         NEMX=200,     NE_R_MX=NEMX,   NFMX=1000,  
     '  NGMX=36,         NHMX=6,       NIMX=3,         NIMAGEMX=1,
     '  NIQMX=1,         NIYMX=16,     NJMX=6,         NKMX=4,
     '  NLMX=1000,       NLCMX=1,      NL_R_MX=NLMX,   NMMX=1,  
     '  NNMX=4,          NOMX=1800,    NOPMX=1,        NORMX=1, 
     '  NOYMX=1,         NPMX=200,     NPDMX=1,        NP_R_MX=NPMX,
     '  NPTMX=1,         NQMX=1,       NRMX=1,         NRCMX=2,
     '  NREMX=1,         NSMX=16,      NTMX=1,         NUMX=10,
     '  NVMX=1,          NWMX=3,       NXMX=1,         NYMX=3600,
     '  NYOMX=1,         NY_R_MX=1800,
     '  NYROWMX=NY_R_MX, NY_TRANSFER_MX=1,            
!     '  NZMX=MAX(NOMX*NOMX,NYROWMX*NYROWMX,6000),
     '  NZMX=NYROWMX*NYROWMX,
     '  NZ_FNY_MX =1,
     '  NZ_GD_MX  =NYROWMX,
     '  NZ_GK_MX  =NYROWMX*NYROWMX,
     '  NZ_GKK_MX =NOMX*NOMX,
     '  NZ_GM_MX  =1,
     '  NZ_GMM_MX =1,
     '  NZ_GQ_MX  =NZMX,
     '  NZ_NZNY_MX=1,
!       Setting sparsity array sizes
!       See above sparsity/solver comment before changing sizes
     '  NISC_GDMX  =1,                  !no sparsity
     '  NISR_GDMX  =1,                  !no sparsity
     '  NISC_GKMX  =NYROWMX+1+NZ_GK_MX, !compressed row
     '  NISR_GKMX  =1,                  !compressed row
     '  NISC_GKKMX =NYROWMX+1+NZ_GKK_MX,!compressed row/harwell
     '  NISR_GKKMX =NZ_GKK_MX,          !compressed row/harwell
     '  NISC2_GKKMX=NZ_GKK_MX,          !only required for sparse LU
     '  NISR2_GKKMX=NZ_GKK_MX,          !only required for sparse LU
     '  NISC_GQMX  =NYROWMX+1+NZ_GQ_MX, !compressed row
     '  NISR_GQMX  =1,                  !compressed row
     '  NZ_MINOS=NOPMX*(NCOMX+NLCMX),
     '  NZ_ITERATIVE_MX=NZ_GKK_MX,
     '  N_ITERATIVE_MX=104,
     '  NEFMX=MAX(NEMX,NFMX), 
     '  NEQMX=MAX(NEMX,NQMX),
     '  NLISTMX=MAX(NEMX,NPMX,NLMX,NDMX),     
     '  NOOPMX=MAX(NOMX,NOPMX),
     '  USE_BEM=1,          USE_DATA=0,        USE_GRAPHICS=0,
     '	USE_GRID=0,         USE_ITERATIVE=1,   USE_LUNG=0, 
     '  USE_MINOS=0,        USE_NLSTRIPE=0,    USE_NONLIN=0,
     '	USE_NPSOL=1,        USE_SPARSE=1,      USE_TRANSFER=0)
