# If the example path is not set, default to current directory
if (! defined $example) {
    $example = "./";
}
# Drop off the trailing / in the example path
$chopped = chop $example;
if ($chopped ne "/") {
    $example .= $chopped;
}

fem define parameters;r;$example/cellml;
fem define node;d;
fem define bas;d;
fem define elem;d;
fem define grid;d;
fem update grid geometry;
fem update grid metric;
fem define equation;r;$example/cellml;
fem define cell;r;$example/jafri_rice_winslow_model_1998;
fem define material;d cell;
fem define material;d;
fem update grid material;
fem define initial;d;
fem define solve;r;$example/lsoda;
fem solve to 0;
fem open history;jafri_rice_winslow_model_1998 write variables yqs niqslist 1..48 binary;
$Tend = 1500;
$dt = 1.0;
for ($time=0;$time<$Tend;$time+=$dt) {
    fem solve restart to $time;
    fem write history time $time variables yqs binary;
}
fem close history binary;
fem evaluate electrode;jafri_rice_winslow_model_1998 history jafri_rice_winslow_model_1998 from grid yqs iy 1..48 binary;
fem define export;r;$example/jafri_rice_winslow_model_1998;
fem export signal;jafri_rice_winslow_model_1998 electrodes signal jafri_rice_winslow_model_1998 names cell;

# For testing we compare the generated CMISS signal files
if ($TESTING) {
    fem compare signal;jafri_rice_winslow_model_1998 basis both masterfile $example/jafri_rice_winslow_model_1998 comparefile jafri_rice_winslow_model_1998 binary;
}
