###################################################
#
# This example illustrates face fitting of the 
# rectus femoris muscle to data from the visible man
#
###################################################

$tot_itt=5;
fem def para;r;rectus_volume;example
fem def coord 3,1
fem def nodes;r;linear_volume_rectus;example
fem def bases;r;bicubic_linear;example
fem def elem;r;linear_volume_rectus;example

fem update nodes derivative 1 linear;   
fem update nodes derivative 2 linear; 
fem update nodes derivative 3 linear; 

#fem export node;initial_volume_rectus as initial_volume_rectus offset 1000
#fem export elem;initial_volume_rectus as initial_volume_rectus offset_elem 1000 

fem def field;r;volume_rectus;example   
fem def elem;r;volume_rectus;example field
fem update field from geometry               

fem def data;r;rectus_femoris;example
#fem exp data;rectus_femoris as rectus_femoris

#fem def xi;c closest_face external 
#fem def xi;w volume_rectus closest_face external            
fem def xi;r;rectus_femoris;example closest_face external
fem li data error                             

for ($fit_itt=1; $fit_itt<=$tot_itt; $fit_itt=$fit_itt+1)
{
  fem def fit;r;volume_rectus;example geometry 
  fem fit
  fem update node fit
  fem update scale_factor normalise
  fem def xi;c closest_face external 
  system "echo ' ======================================================' "    
  fem li data error
  system "echo ' ITERATION ${fit_itt} DONE' "
  system "echo ' ======================================================' "
}

#fem export nodes;final_volume_rectus as final_volume_rectus offset 2000
#fem export elem;final_volume_rectus as final_volume_rectus offset_elem 2000 
