#!/usr/local/perl5.6/bin//perl

# ........................................................................

# Name : muscle_arc_length.pl

# Author : Justin Fernandez (jw.fernandez@auckland.ac.nz)

# Date : 11.11.2004

# Last Modified  

# Description :Reads opline  files and get arc-length.
#               
#               


# Usage : 

# ........................................................................


# get input arguments
$input_file = "lines";

$output_file1 = "SM_muscle.txt";
$output_file2 = "SM_tendon.txt";
$output_file3 = "SM_total.txt";
$output_file4 = "GT_muscle.txt";
$output_file5 = "GT_tendon.txt";
$output_file6 = "GT_total.txt";

# file information
# Open output file.
 open (output1, ">$output_file1") or die "Error opening "; 
 open (output2, ">$output_file2") or die "Error opening "; 
 open (output3, ">$output_file3") or die "Error opening "; 
 open (output4, ">$output_file4") or die "Error opening ";  
 open (output5, ">$output_file5") or die "Error opening "; 
 open (output6, ">$output_file6") or die "Error opening "; 
 
 
# Mesh line information
# GT muscle Lines:
# 8429,8711,8718,8725,8732
# GT tendon Lines:
# 8292,8337,8370,8397,8674,8683,8690,8697,8704
# SM muscle Lines:
# 8843..8846
# SM tendon Lines:
# 8842,8847
 
 
for($z=1;$z<56;$z++)
{
 $open_file=$input_file."_".$z.".opline";
 # Open input file.
 open (input,$open_file) or die "Error opening ";
 $sum[$z]=0; 
 @list_SM_muscle = (8843,8844,8845,8846);
 @list_SM_tendon = (8842,8847); 
 @list_GT_muscle = (8429,8711,8718,8725,8732);
 @list_GT_tendon = (8292,8337,8370,8397,8674,8683,8690,8697,8704);  
  
 while ($line = <input>) 
 { 
  @components = split(/\s+/,$line);
  foreach $j (@list_SM_muscle)
  {       
    if ($components[1]==$j)
    {
       $sumSM[$z]=$sumSM[$z]+$components[8];       
    }        
  } 
  foreach $p (@list_SM_tendon)
  {       
    if ($components[1]==$p)
    {
       $sumSMT[$z]=$sumSMT[$z]+$components[8];       
    }        
  }   
  foreach $q (@list_GT_muscle)
  {       
    if ($components[1]==$q)
    {
       $sumGT[$z]=$sumGT[$z]+$components[8];       
    }        
  } 
  foreach $r (@list_GT_tendon)
  {       
    if ($components[1]==$r)
    {
       $sumGTT[$z]=$sumGTT[$z]+$components[8];       
    }        
  }        
 }
 
# $y=100*(($z-1)/55);
# print output1 $y ." ".$sumsem[$z] . "\n";  
# ##########################################
# $sumsem_norm[$z]=$sumsem[$z]/470.50805413608;
# ##########################################
# print output2 $y ." ".$sumsem_norm[$z] . "\n"; 
 
 
# print output3 $y ." ".($sumgas1[$z]+($sumgas2[$z])/2) . "\n";  
# ##########################################
# $sum_norm_gas[$z]=($sumgas1[$z]+($sumgas2[$z]/2))/375.428914858695;
# ##########################################
# print output4 $y ." ".$sum_norm_gas[$z] . "\n";  

 $y=100*(($z-1)/55);
 print output1 $y ." ".1.08*$sumSM[$z]/340.79 . "\n"; 
 print output2 $y ." ".$sumSMT[$z]/340.79 . "\n";
 print output3 $y ." ".($sumSMT[$z]+1.08*$sumSM[$z])/340.79 . "\n"; 
 print output4 $y ." ".$sumGT[$z]/286.39 . "\n";  
 print output5 $y ." ".$sumGTT[$z]/286.39 . "\n"; 
 print output6 $y ." ".($sumGT[$z]+$sumGTT[$z])/286.39 . "\n"; 

  
 
# Close the files.
close input; 
}
close output1;
close output2;
close output3;
close output4;
close output5;
close output6;





