#gfx cre axes length 500
#gfx draw axes

###############
#Read in host
gfx read nodes host_zero_semimembranosus
gfx read elem host_zero_semimembranosus
gfx read nodes host_zero_gastrocnemius
gfx read elem host_zero_gastrocnemius

gfx modify g_element host_semimembranosus general clear circle_discretization 6 default_coordinate coordinates element_discretization "4*4*4" native_discretization none;
gfx modify g_element host_semimembranosus lines select_on material black selected_material default_selected;
gfx modify g_element host_gastrocnemius general clear circle_discretization 6 default_coordinate coordinates element_discretization "4*4*4" native_discretization none;
gfx modify g_element host_gastrocnemius lines select_on material black selected_material default_selected;

##################################

# bone_list
@bone_list = ('femur','tibia','hip','foot');
foreach $component (@bone_list)
{ 
#Read in bone
gfx read nodes initial_$component
gfx read elem initial_$component

#Commands for reproducing group simulate_$component on scene default:
gfx modify g_element $component general clear circle_discretization 6 default_coordinate coordinates element_discretization "1*1*1" native_discretization none;
gfx modify g_element $component lines select_on material silver selected_material default_selected;
gfx modify g_element $component surfaces select_on material bone selected_material default_selected render_shaded;
}

###################
# muscle_list
@muscle_list = ('gastrocnemius','semimembranosus');
foreach $component (@muscle_list)
{ 
#Read in muscle
gfx read nodes initial_$component
gfx read elem initial_$component

#Commands for reproducing group simulate_$component on scene default:
gfx modify g_element $component general clear circle_discretization 6 default_coordinate coordinates element_discretization "4*4*4" native_discretization none;
gfx modify g_element $component lines select_on material silver selected_material default_selected;
gfx modify g_element $component surfaces select_on material muscle selected_material default_selected render_shaded;
}


#Elements: semimembranosus
#16017..16024
gfx cre egroup semimemten
gfx mod egroup semimemten add 16017..16024
gfx modify g_element semimemten surfaces select_on material tissue selected_material default_selected render_shaded; 


#Elements: gastrocnemius
#25001..25040,25089..25096,25105..25112
gfx cre egroup gastten
gfx mod egroup gastten add 25001..25040,25089..25096,25105..25112
gfx modify g_element gastten surfaces select_on material tissue selected_material default_selected render_shaded; 


gfx set order object semimemten position 1
gfx set order object gastten position 2

# window commands
gfx create window 1 double_buffer;
gfx modify window 1 image scene default light_model default;
gfx modify window 1 image add_light default;
gfx modify window 1 layout simple ortho_axes z -y eye_spacing 0.25 width 1140 height 980;
gfx modify window 1 set current_pane 1;
gfx modify window 1 background colour 1 1 1 texture none;
gfx modify window 1 view parallel eye_point 2567.78 -1770.26 310.267 interest_point 1946.23 -210.787 372.661 up_vector 0.20062 0.0407979 0.978819 view_angle 51.3668 near_clipping_plane 16.7993 far_clipping_plane 6003.5 relative_viewport ndc_placement -1 1 2 2 viewport_coordinates 0 0 1 1;
gfx modify window 1 overlay scene none;
gfx modify window 1 set transform_tool current_pane 1 std_view_angle 40 normal_lines no_antialias fast_transparency blend_normal;
