# ........................................................................

# Name : create_ipacti_muscle_paper.pl

# Author : Justin Fernandez (jw.fernandez@auckland.ac.nz)

# Date : 25.11.2004

# Last Modified : 25.11.2004

# Description : Creates ipacti files for muscle paper


# Usage : Perl math lib (Math:Bigfloat, Math::Trig, Math::Matrix)

# ........................................................................
BEGIN { push @INC, "/home/soe/jfer004/perl_routines/"; }

use Math::BigFloat;
use Math::Trig;
# Math matrix.pm is located in /home/soe/jfer004/perl_routines/Math/
use Math::Matrix;

$file=1;
for($t=0.0;$t<0.1;$t=$t+0.006)
{

$output_file = $file.".ipacti";
# Open output file.
open (output_text, ">$output_file") or die "Error opening ";

$cao=0.01;
$cam=0.3;
$tau=0.06;

#$cao+($cam-$cao)*($t/$tau)*exp(1-($t/$tau));

$ca[1]=$cao+($cam-$cao)*($t/$tau)*exp(1-($t/$tau));
$ca[2]=$cao+($cam-$cao)*(($t-0.006)/$tau)*exp(1-(($t-0.006)/$tau));
if ($ca[2]<0.0){$ca[2]=0.0}
$ca[3]=$cao+($cam-$cao)*(($t-0.012)/$tau)*exp(1-(($t-0.012)/$tau));
if ($ca[3]<0.0){$ca[3]=0.0}
$ca[4]=$cao+($cam-$cao)*(($t-0.018)/$tau)*exp(1-(($t-0.018)/$tau));
if ($ca[4]<0.0){$ca[4]=0.0}
$ca[5]=$cao+($cam-$cao)*(($t-0.024)/$tau)*exp(1-(($t-0.024)/$tau));
if ($ca[5]<0.0){$ca[5]=0.0}
$ca[6]=$cao+($cam-$cao)*(($t-0.030)/$tau)*exp(1-(($t-0.030)/$tau));
if ($ca[6]<0.0){$ca[6]=0.0}

print output_text" CMISS Version 2.0  ipacti File Version 2"."\n";
print output_text" Heading: penalty test for hermite element"."\n";
print output_text" "."\n"; 
print output_text" Specify type of contraction model [2]:"."\n";
print output_text"   (1) SS tension-length-Ca relation (OLD)"."\n";
print output_text"   (2) Hunter/McCulloch/ter Keurs (coupled to cell/grid model)"."\n";
print output_text"   (3) Unused"."\n";
print output_text"   (4) Outer hair cell stiffness"."\n";
print output_text"    1"."\n";
print output_text" Enter max isometric tension at ext.ratio=1 (Tref) [100kPa]: 0.0001"."\n";
print output_text" Enter non-dimensional slope parameter (beta) [1.45]: 0.14500D+01"."\n";
print output_text" Enter c50 for [Ca]i saturation curve (0<c<1) [0.5]: 0.50000D+00"."\n";
print output_text" Enter Hill coeff. for [Ca]i saturation curve (h) [3.0]: 0.30000D+01"."\n";
print output_text" Enter max [Ca]i (Ca_max) [1]: 0.10000D+01"."\n";
print output_text" Specify whether the initial calcium level [Ca]i is [1]:"."\n";
print output_text"  (1) Constant spatially"."\n";
print output_text"  (2) Piecewise constant (defined by elements)"."\n";
print output_text"  (3) Defined by Gauss points"."\n";
print output_text"   3"."\n";
print output_text" Enter element #s/name [EXIT]: 14001"."\n";
print output_text" Gauss Point #s[EXIT]: 1..64"."\n";
print output_text" The value is [0.100D+01]: 0.01"."\n";
print output_text" Gauss Point #s[EXIT]: 4..16,20..32,36..48,52..64"."\n";
print output_text" The value is [0.100D+01]: ".$ca[3]."\n";
print output_text" Gauss Point #s[EXIT]: 3..15,19..31,35..47,51..63"."\n";
print output_text" The value is [0.100D+01]: ".$ca[4]."\n"; 
print output_text" Gauss Point #s[EXIT]: 2..14,18..30,34..46,50..62"."\n";
print output_text" The value is [0.100D+01]: ".$ca[5]."\n";   
print output_text" Gauss Point #s[EXIT]: 1..13,17..21,33..45,49..61"."\n";
print output_text" The value is [0.100D+01]: ".$ca[6]."\n";   
print output_text" Gauss Point #s[EXIT]: 0"."\n"; 
print output_text" Enter element #s/name [EXIT]: 14002"."\n";
print output_text" Gauss Point #s[EXIT]: 1..64"."\n";
print output_text" The value is [0.100D+01]: 0.01"."\n";  
print output_text" Gauss Point #s[EXIT]: 3..15,2..14,19..31,18..30,35..47,34..46,51..63,50..62"."\n";
print output_text" The value is [0.100D+01]: ".$ca[1]."\n";
print output_text" Gauss Point #s[EXIT]: 4..16,1..13,20..32,17..29,36..48,33..45,52..64,49..61"."\n";
print output_text" The value is [0.100D+01]: ".$ca[2]."\n";
print output_text" Gauss Point #s[EXIT]: 0"."\n"; 
print output_text" Enter element #s/name [EXIT]: 14003"."\n";
print output_text" Gauss Point #s[EXIT]: 1..64"."\n";
print output_text" The value is [0.100D+01]: 0.01"."\n";
print output_text" Gauss Point #s[EXIT]: 1..13,17..21,33..45,49..61"."\n";
print output_text" The value is [0.100D+01]: ".$ca[3]."\n";
print output_text" Gauss Point #s[EXIT]: 2..14,18..30,34..46,50..62"."\n";
print output_text" The value is [0.100D+01]: ".$ca[4]."\n";
print output_text" Gauss Point #s[EXIT]: 3..15,19..31,35..47,51..63"."\n";
print output_text" The value is [0.100D+01]: ".$ca[5]."\n";
print output_text" Gauss Point #s[EXIT]: 4..16,20..32,36..48,52..64"."\n";
print output_text" The value is [0.100D+01]: ".$ca[6]."\n";
print output_text" Gauss Point #s[EXIT]: 0"."\n"; 
print output_text" Enter element #s/name [EXIT]: 0"."\n";  


# Close the files.
close output_text;

$file++;

}


for($t=0.1;$t<0.5;$t=$t+0.05)
{

$output_file = $file.".ipacti";
# Open output file.
open (output_text, ">$output_file") or die "Error opening ";

$cao=0.01;
$cam=0.1;
$tau=0.06;

#$cao+($cam-$cao)*($t/$tau)*exp(1-($t/$tau));

$ca[1]=$cao+($cam-$cao)*($t/$tau)*exp(1-($t/$tau));
$ca[2]=$cao+($cam-$cao)*(($t-0.006)/$tau)*exp(1-(($t-0.006)/$tau));
if ($ca[2]<0.0){$ca[2]=0.0}
$ca[3]=$cao+($cam-$cao)*(($t-0.012)/$tau)*exp(1-(($t-0.012)/$tau));
if ($ca[3]<0.0){$ca[3]=0.0}
$ca[4]=$cao+($cam-$cao)*(($t-0.018)/$tau)*exp(1-(($t-0.018)/$tau));
if ($ca[4]<0.0){$ca[4]=0.0}
$ca[5]=$cao+($cam-$cao)*(($t-0.024)/$tau)*exp(1-(($t-0.024)/$tau));
if ($ca[5]<0.0){$ca[5]=0.0}
$ca[6]=$cao+($cam-$cao)*(($t-0.030)/$tau)*exp(1-(($t-0.030)/$tau));
if ($ca[6]<0.0){$ca[6]=0.0}

print output_text" CMISS Version 2.0  ipacti File Version 2"."\n";
print output_text" Heading: penalty test for hermite element"."\n";
print output_text" "."\n"; 
print output_text" Specify type of contraction model [2]:"."\n";
print output_text"   (1) SS tension-length-Ca relation (OLD)"."\n";
print output_text"   (2) Hunter/McCulloch/ter Keurs (coupled to cell/grid model)"."\n";
print output_text"   (3) Unused"."\n";
print output_text"   (4) Outer hair cell stiffness"."\n";
print output_text"    1"."\n";
print output_text" Enter max isometric tension at ext.ratio=1 (Tref) [100kPa]: 0.0001"."\n";
print output_text" Enter non-dimensional slope parameter (beta) [1.45]: 0.14500D+01"."\n";
print output_text" Enter c50 for [Ca]i saturation curve (0<c<1) [0.5]: 0.50000D+00"."\n";
print output_text" Enter Hill coeff. for [Ca]i saturation curve (h) [3.0]: 0.30000D+01"."\n";
print output_text" Enter max [Ca]i (Ca_max) [1]: 0.10000D+01"."\n";
print output_text" Specify whether the initial calcium level [Ca]i is [1]:"."\n";
print output_text"  (1) Constant spatially"."\n";
print output_text"  (2) Piecewise constant (defined by elements)"."\n";
print output_text"  (3) Defined by Gauss points"."\n";
print output_text"   3"."\n";
print output_text" Enter element #s/name [EXIT]: 14001"."\n";
print output_text" Gauss Point #s[EXIT]: 1..64"."\n";
print output_text" The value is [0.100D+01]: 0.01"."\n";
print output_text" Gauss Point #s[EXIT]: 4..16,20..32,36..48,52..64"."\n";
print output_text" The value is [0.100D+01]: ".$ca[3]."\n";
print output_text" Gauss Point #s[EXIT]: 3..15,19..31,35..47,51..63"."\n";
print output_text" The value is [0.100D+01]: ".$ca[4]."\n"; 
print output_text" Gauss Point #s[EXIT]: 2..14,18..30,34..46,50..62"."\n";
print output_text" The value is [0.100D+01]: ".$ca[5]."\n";   
print output_text" Gauss Point #s[EXIT]: 1..13,17..21,33..45,49..61"."\n";
print output_text" The value is [0.100D+01]: ".$ca[6]."\n";   
print output_text" Gauss Point #s[EXIT]: 0"."\n"; 
print output_text" Enter element #s/name [EXIT]: 14002"."\n";
print output_text" Gauss Point #s[EXIT]: 1..64"."\n";
print output_text" The value is [0.100D+01]: 0.01"."\n";  
print output_text" Gauss Point #s[EXIT]: 3..15,2..14,19..31,18..30,35..47,34..46,51..63,50..62"."\n";
print output_text" The value is [0.100D+01]: ".$ca[1]."\n";
print output_text" Gauss Point #s[EXIT]: 4..16,1..13,20..32,17..29,36..48,33..45,52..64,49..61"."\n";
print output_text" The value is [0.100D+01]: ".$ca[2]."\n";
print output_text" Gauss Point #s[EXIT]: 0"."\n"; 
print output_text" Enter element #s/name [EXIT]: 14003"."\n";
print output_text" Gauss Point #s[EXIT]: 1..64"."\n";
print output_text" The value is [0.100D+01]: 0.01"."\n";
print output_text" Gauss Point #s[EXIT]: 1..13,17..21,33..45,49..61"."\n";
print output_text" The value is [0.100D+01]: ".$ca[3]."\n";
print output_text" Gauss Point #s[EXIT]: 2..14,18..30,34..46,50..62"."\n";
print output_text" The value is [0.100D+01]: ".$ca[4]."\n";
print output_text" Gauss Point #s[EXIT]: 3..15,19..31,35..47,51..63"."\n";
print output_text" The value is [0.100D+01]: ".$ca[5]."\n";
print output_text" Gauss Point #s[EXIT]: 4..16,20..32,36..48,52..64"."\n";
print output_text" The value is [0.100D+01]: ".$ca[6]."\n";
print output_text" Gauss Point #s[EXIT]: 0"."\n"; 
print output_text" Enter element #s/name [EXIT]: 0"."\n";  


# Close the files.
close output_text;

$file++;

}
