# ........................................................................

# Name : extract_gauss_stress.pl

# Author : Justin Fernandez (jw.fernandez@auckland.ac.nz)

# Date : 23.11.2004

# Last Modified : 23.11.2004

# Description : Extracts gauss point stresses for muscle paper



# Usage : Perl math lib (Math:Bigfloat, Math::Trig, Math::Matrix)

# ........................................................................
BEGIN { push @INC, "/home/soe/jfer004/perl_routines/"; }

use Math::BigFloat;
use Math::Trig;
# Math matrix.pm is located in /home/soe/jfer004/perl_routines/Math/
use Math::Matrix;

#10 degress
#if(($i>5)&&($i<32))

# 30 degress activation
#if(($i>54)&&($i<81))

# 60 degress activation
#if(($i>101)&&($i<128))

for($file=6;$file<32;$file++)
{
# get input arguments
$input_file1 = "passive_stress_rectus_patella_".$file.".ipgaus";
$output_file1 = "0.1passive_10d_g1.txt";
$output_file2 = "0.1passive_10d_g2.txt";
$output_file3 = "0.1passive_10d_g3.txt";

# Open input file1
open (input_text1,$input_file1) or die "Error opening ";

# Open output file1.
open (output_text1, ">$output_file1") or die "Error opening ";
# Open output file2.
open (output_text2, ">$output_file2") or die "Error opening ";
# Open output file3.
open (output_text3, ">$output_file3") or die "Error opening ";

$g1=1;
$g2=1;
$g3=1;
while ($line = <input_text1>) 
{
    if ($line =~ /YG at ne=14001 ng= 18 is \[0\]:/) 
    {   
      @components = split(/\:/,$line); 
      $stress1[$file][$g1]=$components[1];      
#      print $stress1[$file][1]."\n";
#      print $stress1[$file][2]."\n"; 
#      print $stress1[$file][3]."\n";            
      $g1++;
    }
    if ($line =~ /YG at ne=14002 ng= 18 is \[0\]:/) 
    {   
      @components = split(/\:/,$line); 
      $stress2[$file][$g2]=$components[1];      
#      print $stress2[$file][1]."\n";
#      print $stress2[$file][2]."\n"; 
#      print $stress2[$file][3]."\n";            
      $g2++;
    } 
    if ($line =~ /YG at ne=14003 ng= 18 is \[0\]:/) 
    {   
      @components = split(/\:/,$line); 
      $stress3[$file][$g3]=$components[1];      
#      print $stress3[$file][1]."\n";
#      print $stress3[$file][2]."\n"; 
#      print $stress3[$file][3]."\n";            
      $g3++;
    }    
                 
}

# Close the files.
close input_text1;
}

for($file=6;$file<32;$file++)
{
  print output_text1 $stress1[$file][1]."\n";
  print output_text2 $stress2[$file][1]."\n"; 
  print output_text3 $stress3[$file][1]."\n";   
}

close output_text1;

#10 degress
#if(($i>5)&&($i<32))

# 30 degress activation
#if(($i>54)&&($i<81))

# 60 degress activation
#if(($i>101)&&($i<128))

for($file=55;$file<81;$file++)
{
# get input arguments
$input_file1 = "passive_stress_rectus_patella_".$file.".ipgaus";
$output_file1 = "0.1passive_30d_g1.txt";
$output_file2 = "0.1passive_30d_g2.txt";
$output_file3 = "0.1passive_30d_g3.txt";

# Open input file1
open (input_text1,$input_file1) or die "Error opening ";

# Open output file1.
open (output_text1, ">$output_file1") or die "Error opening ";
# Open output file2.
open (output_text2, ">$output_file2") or die "Error opening ";
# Open output file3.
open (output_text3, ">$output_file3") or die "Error opening ";

$g1=1;
$g2=1;
$g3=1;
while ($line = <input_text1>) 
{
    if ($line =~ /YG at ne=14001 ng= 18 is \[0\]:/) 
    {   
      @components = split(/\:/,$line); 
      $stress1[$file][$g1]=$components[1];      
#      print $stress1[$file][1]."\n";
#      print $stress1[$file][2]."\n"; 
#      print $stress1[$file][3]."\n";            
      $g1++;
    }
    if ($line =~ /YG at ne=14002 ng= 18 is \[0\]:/) 
    {   
      @components = split(/\:/,$line); 
      $stress2[$file][$g2]=$components[1];      
#      print $stress2[$file][1]."\n";
#      print $stress2[$file][2]."\n"; 
#      print $stress2[$file][3]."\n";            
      $g2++;
    } 
    if ($line =~ /YG at ne=14003 ng= 18 is \[0\]:/) 
    {   
      @components = split(/\:/,$line); 
      $stress3[$file][$g3]=$components[1];      
#      print $stress3[$file][1]."\n";
#      print $stress3[$file][2]."\n"; 
#      print $stress3[$file][3]."\n";            
      $g3++;
    }    
                 
}

# Close the files.
close input_text1;
}

for($file=55;$file<81;$file++)
{
  print output_text1 $stress1[$file][1]."\n";
  print output_text2 $stress2[$file][1]."\n"; 
  print output_text3 $stress3[$file][1]."\n";   
}

close output_text1;


#10 degress
#if(($i>5)&&($i<32))

# 30 degress activation
#if(($i>54)&&($i<81))

# 60 degress activation
#if(($i>101)&&($i<128))

for($file=102;$file<128;$file++)
{
# get input arguments
$input_file1 = "passive_stress_rectus_patella_".$file.".ipgaus";
$output_file1 = "0.1passive_60d_g1.txt";
$output_file2 = "0.1passive_60d_g2.txt";
$output_file3 = "0.1passive_60d_g3.txt";

# Open input file1
open (input_text1,$input_file1) or die "Error opening ";

# Open output file1.
open (output_text1, ">$output_file1") or die "Error opening ";
# Open output file2.
open (output_text2, ">$output_file2") or die "Error opening ";
# Open output file3.
open (output_text3, ">$output_file3") or die "Error opening ";

$g1=1;
$g2=1;
$g3=1;
while ($line = <input_text1>) 
{
    if ($line =~ /YG at ne=14001 ng= 18 is \[0\]:/) 
    {   
      @components = split(/\:/,$line); 
      $stress1[$file][$g1]=$components[1];      
#      print $stress1[$file][1]."\n";
#      print $stress1[$file][2]."\n"; 
#      print $stress1[$file][3]."\n";            
      $g1++;
    }
    if ($line =~ /YG at ne=14002 ng= 18 is \[0\]:/) 
    {   
      @components = split(/\:/,$line); 
      $stress2[$file][$g2]=$components[1];      
#      print $stress2[$file][1]."\n";
#      print $stress2[$file][2]."\n"; 
#      print $stress2[$file][3]."\n";            
      $g2++;
    } 
    if ($line =~ /YG at ne=14003 ng= 18 is \[0\]:/) 
    {   
      @components = split(/\:/,$line); 
      $stress3[$file][$g3]=$components[1];      
#      print $stress3[$file][1]."\n";
#      print $stress3[$file][2]."\n"; 
#      print $stress3[$file][3]."\n";            
      $g3++;
    }    
                 
}

# Close the files.
close input_text1;
}

for($file=102;$file<128;$file++)
{
  print output_text1 $stress1[$file][1]."\n";
  print output_text2 $stress2[$file][1]."\n"; 
  print output_text3 $stress3[$file][1]."\n";   
}

close output_text1;

