@muscle_list = ('single_rectus','femur','tibia');

foreach $component (@muscle_list)
{ 

#Read in muscle
gfx read nodes init_$component
gfx read elem init_$component

}

gfx modify g_element single_rectus general clear circle_discretization 6 default_coordinate coordinates element_discretization "1*1*1" native_discretization none;
gfx modify g_element single_rectus surfaces select_on material muscle selected_material default_selected render_shaded;

gfx modify g_element femur general clear circle_discretization 6 default_coordinate coordinates element_discretization "1*1*1" native_discretization none;
gfx modify g_element femur surfaces select_on material bone selected_material default_selected render_shaded;

gfx modify g_element tibia general clear circle_discretization 6 default_coordinate coordinates element_discretization "1*1*1" native_discretization none;
gfx modify g_element tibia surfaces select_on material bone selected_material default_selected render_shaded;

gfx cre axes length 200
gfx draw axes

gfx create material green ambient 0.5 0.5 0 diffuse 0.76 1 0.61 emission 0 0 0 specular 1 1 1 alpha 1 shininess 0.03;

gfx cre egroup vbone
gfx mod egroup vbone add 1..9,19..27
gfx cre egroup vten
gfx mod egroup vten add 14004,24004,24008..24010
gfx cre egroup vcar
gfx mod egroup vcar add 10..18

gfx set order object vbone position 1
gfx set order object vten position 2
gfx set order object vcar position 3

#Commands for reproducing group vbone on scene default:
gfx modify g_element vbone general clear circle_discretization 6 default_coordinate coordinates element_discretization "1*1*1" native_discretization none;
gfx modify g_element vbone lines select_on material silver selected_material default_selected;
gfx modify g_element vbone surfaces exterior select_on material bone selected_material default_selected render_shaded;
#Commands for reproducing group vten on scene default:
gfx modify g_element vten general clear circle_discretization 6 default_coordinate coordinates element_discretization "1*1*1" native_discretization none;
gfx modify g_element vten lines select_on material silver selected_material default_selected;
gfx modify g_element vten surfaces exterior select_on material tissue selected_material default_selected render_shaded;
#Commands for reproducing group vcar on scene default:
gfx modify g_element vcar general clear circle_discretization 6 default_coordinate coordinates element_discretization "1*1*1" native_discretization none;
gfx modify g_element vcar lines select_on material silver selected_material default_selected;
gfx modify g_element vcar surfaces select_on material green selected_material default_selected render_shaded;
#Commands for reproducing group single_rectus on scene default:
gfx modify g_element single_rectus general clear circle_discretization 6 default_coordinate coordinates element_discretization "1*1*1" native_discretization none;
gfx modify g_element single_rectus lines select_on material silver selected_material default_selected;
gfx modify g_element single_rectus surfaces select_on material muscle selected_material default_selected render_shaded;
#Commands for reproducing group femur on scene default:
gfx modify g_element femur general clear circle_discretization 6 default_coordinate coordinates element_discretization "1*1*1" native_discretization none;
gfx modify g_element femur lines select_on material silver selected_material default_selected;
gfx modify g_element femur surfaces select_on material bone selected_material default_selected render_shaded;
#Commands for reproducing group tibia on scene default:
gfx modify g_element tibia general clear circle_discretization 6 default_coordinate coordinates element_discretization "1*1*1" native_discretization none;
gfx modify g_element tibia lines select_on material silver selected_material default_selected;
gfx modify g_element tibia surfaces select_on material bone selected_material default_selected render_shaded;


# for side view
#Commands for reproducing group single_rectus on scene default:
#gfx modify g_element single_rectus general clear circle_discretization 6 default_coordinate coordinates element_discretization "1*1*1" native_discretization none;
#gfx modify g_element single_rectus lines select_on material silver selected_material default_selected;
gfx create window 1 double_buffer;
gfx modify window 1 image scene default light_model default;
gfx modify window 1 image add_light default;
gfx modify window 1 layout simple ortho_axes z -y eye_spacing 0.25 width 549 height 552;
gfx modify window 1 set current_pane 1;
gfx modify window 1 background colour 1 1 1 texture none;
gfx modify window 1 view parallel eye_point -2006.16 -167.353 303.809 interest_point 3.69537 -6.53662 -17.0393 up_vector 0.144728 0.144238 0.978902 view_angle 7.37394 near_clipping_plane 20.4165 far_clipping_plane 7296.15 relative_viewport ndc_placement -1 1 2 2 viewport_coordinates 0 0 1 1;
gfx modify window 1 overlay scene none;
gfx modify window 1 set transform_tool current_pane 1 std_view_angle 40 normal_lines no_antialias fast_transparency blend_normal;

## for front view
#gfx create window 1 double_buffer;
#gfx modify window 1 image scene default light_model default;
#gfx modify window 1 image add_light default;
#gfx modify window 1 layout simple ortho_axes z -y eye_spacing 0.25 width 549 height 552;
#gfx modify window 1 set current_pane 1;
#gfx modify window 1 background colour 1 1 1 texture none;
#gfx modify window 1 view parallel eye_point -334.597 1992.18 247.578 interest_point 2.27351 -4.29113 -14.9928 up_vector 0.0626531 -0.119739 0.990826 view_angle 9.63721 near_clipping_plane 20.4165 far_clipping_plane 7296.15 relative_viewport ndc_placement -1 1 2 2 viewport_coordinates 0 0 1 1;
#gfx modify window 1 overlay scene none;
#gfx modify window 1 set transform_tool current_pane 1 std_view_angle 40 normal_lines no_antialias fast_transparency blend_normal;





