#
# Load in subroutines from other files
#
open com example loop_squares.com exec 1
open com example loop_cone.com exec 1
open com example draw_cones.com exec 1

#
# Create some materials
#
gfx create material dred     diffuse 1.0 0.0 0.0 specular 0.6 0.3 0.3 shininess 1.0
gfx create material dblue    diffuse 0.0 0.1 1.0 specular 0.4 0.4 0.5 shininess 0.5 
gfx create material dgreen   diffuse 0.0 0.5 0.0 specular 0.4 0.4 0.5 shininess 0.5 
gfx create material beige    diffuse 1.0 0.8 0.7 specular 1.0 0.6 0.6 shininess 1.0
gfx create material ghost    diffuse 0.6 0.6 0.6 alpha 0.16 
gfx create material dgrey    diffuse 0.2 0.2 0.2 


#
# Read in the meshes and the data
#
gfx read node example epi
gfx read elem example epi
gfx read data example epi
gfx modify g_elem epi line mat dgrey invis
gfx modify g_elem epi surf mat dred invis
gfx modify g_elem epi data coordinate coordinate mat dred glyph cross size 1


gfx read node example lvendo
gfx read elem example lvendo
gfx read data example lvendo
gfx modify g_elem lvendo line mat dgrey
gfx modify g_elem lvendo surf mat dgreen
gfx modify g_elem lvendo data coordinate coordinate mat dgreen glyph cross size 1

gfx read node example rvendo
gfx read elem example rvendo
gfx read data example rvendo
gfx modify g_elem rvendo line mat dgrey
gfx modify g_elem rvendo surf mat dblue
gfx modify g_elem rvendo data coordinate coordinate mat dblue glyph cross size 1



#
# Open window 1 with appropriate view
#
gfx create window 1
gfx modify window 1 image view
gfx modify window 1 set slow
gfx modify window 1 set pert
gfx modify window 1 background colour 0 0 0 all



#
# Create the movie texture
#

$movie = "$ENV{CMISS_EXAMPLES}/e/e5/e53/cmiss_input/rboyes2s02"

gfx movie open "${movie}.mov" name $movie loop

gfx create texture s02movie movie $movie wid 290 heig 217
gfx create material s02movie amb 1. 1. 1. diff 1. 1. 1. alph 1. text s02movie

loop_squares("s01f033", 51000);
#gfx set vis s01f033

loop_squares("s02f135", 52000);

loop_squares("s05f008", 55000);
gfx set vis s05f008

loop_squares("s06f148", 56000);


#
# Masks the other cones ...
#
draw_cones();


#
# Test by exporting to vrml amd write texture
#
gfx export vrml file ultrasound_cones
gfx write tex tex_s06f148 file texture_alpha.rgb rgb


#
# Runs movie texture
#
open com example startmovie.com




