# Updated 11/01/01

# Create some materials
gfx create material SURFACE ambient 1 1 1 diffuse 0 0.26 1 emission 0.26 0 1 specular 0 0 0 alpha 1 shininess 1
gfx create material bladder_surface ambient 0.68 0 0 diffuse 1 0.74 0.6 emission 0.55 0.05 0. specular 1. 0.2 0 alpha 0.3 shininess 1
gfx create material prostate_surface ambient 1 1 1 diffuse 0 0.26 1 emission 0 0 0 specular 0 0 0 alpha 1 shininess 1
gfx create material ureter_surface ambient 1 0.5 0.1 diffuse 0 0.5 0.1 emission 0 0 0 specular 0 0 0 alpha 1 shininess 1
gfx create material default ambient 1 1 1 diffuse 1 1 1 emission 0 0 0 specular 0 0 0 alpha 1 shininess 0
gfx create material default_selected ambient 1 0 0 diffuse 1 0 0 emission 0 0 0 specular 0 0 0 alpha 1 shininess 0
gfx create material tube ambient 1 1 0.16 diffuse 1 1 0.61 emission 0 0 0 specular 1 1 0.21 alpha 1 shininess 1 
gfx create material translucent_tube ambient 1 1 0.16 diffuse 1 1 0.61 emission 0 0 0 specular 1 1 0.21 alpha 0.5 shininess 1 
gfx cre material aqua_blue diff 0.1 0.9 1 amb 0.1 0.9 1 specular 0.8 0.8 0.8 shininess 0.8 
gfx cre material shiny_red       diff 1 0 0     amb 1 0 0     specular 0.8 0.8 0.8 shininess 0.8 
gfx create material jade ambient 0.1 0.56 0 diffuse 0.1 0.39 0 emission 0 0 0 specular 0.8 0.8 0.8 alpha 1 shininess 0.8 
gfx create material purple ambient 0.72 0 1 diffuse 0.5 0 1 emission 0 0 0 specular 1 1 1 alpha 1 shininess 0.8 
gfx cre mat bluey amb 0 0.25 0.5 diff 0 0.4 1 spec 0.5 0.5 0.5 shininess 0.3 
gfx cre mat copper ambient 1 0.2 0 diff 0.6 0.3 0 spec 0.7 0.7 0.5 shin 0.3
gfx cre mat gold amb 1 0.4 0 diff 1 0.7 0 spec 0.5 0.5 0.5 shininess 0.8
gfx create material silver ambient 0.4 0.4 0.4 diffuse 0.7 0.7 0.7 emission 0 0 0 specular 0.7 0.7 0.7 alpha 1 shininess 0.6
gfx create material skin ambient 1 0.2 0 diffuse 0.8 0.7 0.45 emission 0 0 0 specular 0.4 0.2 0.2 alpha 1 shininess 0.2
gfx create material black_skin ambient 0.4 0.1 0.1 diffuse 0.4 0.2 0.1 emission 0 0 0 specular 0.5 0.5 0.5 alpha 1 shininess 0.2
gfx create material red ambient 1 0 0 diffuse 1 0 0
gfx create material green ambient 0 1 0 diffuse 0 1 0
gfx create material inner_bladder_surface ambient 0.68 0 0 diffuse 1 0.74 0.6 emission 0.55 0.05 0. specular 1. 0.2 0 alpha 1 shininess 1



# Read in the node mesh information
gfx read node blad_ref
gfx read element blad_ref

# Create some element groups
gfx cre egroup ureters add_ranges 51..60,69..78 from mesh
gfx cre egroup bladder add_ranges 1..50,137..152 from mesh
gfx cre egroup prostate add_ranges 61..68,137..144 from mesh
gfx cre egroup inner_bladder add_ranges 87..104,108..109,111..114,120..125,156..161 from mesh
gfx cre egroup trigone add_ranges 105..107,110,115..119,126..136,153..155,162..168 from mesh
gfx cre egroup ext_sphincter add_ranges 79..82,145..148 from mesh
gfx cre egroup int_sphincter add_ranges 83..86,149..152 from mesh

# modify the element groups individually.
gfx modify g_element bladder general clear circle_discretization 2 default_coordinate default_coordinate element_discretization "10*10*10" native_discretization none
gfx modify g_element ureters general clear circle_discretization 2 default_coordinate default_coordinate element_discretization "10*10*10" native_discretization none
gfx modify g_element prostate general clear circle_discretization 2 default_coordinate default_coordinate element_discretization "10*10*10" native_discretization none
gfx modify g_element inner_bladder general clear circle_discretization 2 default_coordinate default_coordinate element_discretization "10*10*10" native_discretization none
gfx modify g_element trigone general clear circle_discretization 2 default_coordinate default_coordinate element_discretization "10*10*10" native_discretization none
gfx modify g_element ext_sphincter general clear circle_discretization 2 default_coordinate default_coordinate element_discretization "10*10*10" native_discretization none
gfx modify g_element int_sphincter general clear circle_discretization 2 default_coordinate default_coordinate element_discretization "10*10*10" native_discretization none
gfx modify g_element mesh general clear circle_discretization 2 default_coordinate default_coordinate element_discretization "10*10*10" native_discretization none

# Apply surfaces
gfx modify g_element bladder surfaces select_on material bladder_surface face xi3_0 selected_material default_selected render_shaded
gfx modify g_element prostate surfaces select_on material bladder_surface face xi3_0  selected_material default_selected render_shaded
gfx modify g_element prostate surfaces select_on material tube face xi3_1  selected_material default_selected render_shaded
gfx modify g_element ureters surfaces select_on material tube selected_material default_selected render_shaded
gfx modify g_element inner_bladder surfaces select_on material inner_bladder_surface selected_material default_selected render_shaded
gfx modify g_element trigone surfaces select_on material inner_bladder_surface selected_material default_selected render_shaded
gfx modify g_element int_sphincter surfaces select_on material tube face xi3_1  selected_material default_selected render_shaded
gfx modify g_element ext_sphincter surfaces select_on material tube face xi3_1  selected_material default_selected render_shaded
gfx modify g_element int_sphincter surfaces select_on material translucent_tube face xi3_0  selected_material default_selected render_shaded
gfx modify g_element ext_sphincter surfaces select_on material translucent_tube face xi3_0  selected_material default_selected render_shaded

gfx modify g_element bladder lines select_on material default selected_material default_selected
gfx modify g_element inner_bladder lines select_on material default selected_material default_selected
gfx modify g_element ureters lines select_on material default selected_material default_selected
gfx modify g_element prostate lines select_on material default selected_material default_selected
gfx modify g_element trigone lines select_on material default selected_material default_selected
gfx modify g_element ext_sphincter lines select_on material default selected_material default_selected
gfx modify g_element int_sphincter lines select_on material default selected_material default_selected

#gfx modify g_element bladder element_points glyph arrow_solid general size "0*0.2*0.2" centre 0,0,0 orientation fibres scale_factors "2*0*0" use_elements cell_corners discretization "2*2*1" native_discretization fibres select_on material SURFACE selected_material default_selected

#gfx modify g_element inner_bladder element_points glyph arrow_solid general size "0*0.2*0.2" centre 0,0,0 orientation fibres scale_factors "2*0*0" use_elements cell_corners discretization "2*2*1" native_discretization fibres select_on material SURFACE selected_material default_selected

#gfx modify g_element trigone element_points glyph arrow_solid general size "0*0.2*0.2" centre 0,0,0 orientation fibres scale_factors "2*0*0" use_elements cell_corners discretization "2*2*1" native_discretization fibres select_on material SURFACE selected_material default_selected

#gfx modify g_element ureters element_points glyph arrow_solid general size "0*0.2*0.2" centre 0,0,0 orientation fibres scale_factors "2*0*0" use_elements cell_corners discretization "2*2*1" native_discretization fibres select_on material SURFACE selected_material default_selected

#gfx modify g_element ext_sphincter element_points glyph arrow_solid general size "0*0.2*0.2" centre 0,0,0 orientation fibres scale_factors "2*0*0" use_elements cell_corners discretization "2*2*1" native_discretization fibres select_on material SURFACE selected_material default_selected

#gfx modify g_element int_sphincter element_points glyph arrow_solid general size "0*0.2*0.2" centre 0,0,0 orientation fibres scale_factors "2*0*0" use_elements cell_corners discretization "2*2*1" native_discretization fibres select_on material SURFACE selected_material default_selected

#gfx modify g_element prostate element_points glyph arrow_solid general size "0*0.2*0.2" centre 0,0,0 orientation fibres scale_factors "2*0*0" use_elements cell_corners discretization "2*2*1" native_discretization fibres select_on material SURFACE selected_material default_selected

# Set the order of the objects so the inner objects are visible inside the outer objects.
gfx set order object ureters position 1
gfx set order object inner_bladder position 2
gfx set order object trigone position 3
gfx set order object bladder position 4
gfx set order object int_sphincter position 5
gfx set order object prostate position 6
gfx set order object ext_sphincter position 7

gfx create window 1
gfx mod win 1 image view_all
gfx edit scene
